import { ElementRef, OnDestroy, EventEmitter, QueryList } from '@angular/core';
import { BlockableUI } from '../common/blockableui';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
export declare class Accordion implements BlockableUI {
    el: ElementRef;
    multiple: boolean;
    onClose: EventEmitter<any>;
    onOpen: EventEmitter<any>;
    style: any;
    styleClass: string;
    lazy: boolean;
    private _activeIndex;
    tabs: AccordionTab[];
    constructor(el: ElementRef);
    addTab(tab: AccordionTab): void;
    getBlockableElement(): HTMLElement;
    get activeIndex(): any;
    set activeIndex(val: any);
    static ɵfac: i0.ɵɵFactoryDef<Accordion, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<Accordion, "p-accordion", never, { "multiple": "multiple"; "style": "style"; "styleClass": "styleClass"; "lazy": "lazy"; "activeIndex": "activeIndex"; }, { "onClose": "onClose"; "onOpen": "onOpen"; }, never, ["*"]>;
}
export declare class AccordionTab implements OnDestroy {
    accordion: Accordion;
    header: string;
    selected: boolean;
    disabled: boolean;
    selectedChange: EventEmitter<any>;
    headerFacet: QueryList<AccordionTab>;
    animating: boolean;
    constructor(accordion: Accordion);
    toggle(event: any): boolean;
    findTabIndex(): number;
    get lazy(): boolean;
    get hasHeaderFacet(): boolean;
    onToggleDone(event: Event): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDef<AccordionTab, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<AccordionTab, "p-accordionTab", never, { "header": "header"; "selected": "selected"; "disabled": "disabled"; }, { "selectedChange": "selectedChange"; }, ["headerFacet"], ["p-header", "*"]>;
}
export declare class AccordionModule {
    static ɵmod: i0.ɵɵNgModuleDefWithMeta<AccordionModule, [typeof Accordion, typeof AccordionTab], [typeof i1.CommonModule], [typeof Accordion, typeof AccordionTab]>;
    static ɵinj: i0.ɵɵInjectorDef<AccordionModule>;
}
