"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var animations_1 = require("@angular/animations");
var common_1 = require("@angular/common");
var shared_1 = require("../common/shared");
var i0 = require("@angular/core");
var i1 = require("@angular/common");
var _c0 = ["*"];
function AccordionTab_a_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "a", 5);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    var ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵattribute("aria-expanded", ctx_r0.selected)("aria-selected", ctx_r0.selected);
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(ctx_r0.header);
} }
function AccordionTab_a_3_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "a", 5);
    i0.ɵɵprojection(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    var ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵattribute("aria-expanded", ctx_r1.selected)("aria-selected", ctx_r1.selected);
} }
function AccordionTab_div_5_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 6);
    i0.ɵɵprojection(1, 1);
    i0.ɵɵelementEnd();
} }
var _c1 = [[["p-header"]], "*"];
var _c2 = function (a0, a1) { return { "ui-state-active": a0, "ui-state-disabled": a1 }; };
var _c3 = function (a0, a1) { return { "fa-caret-down": a0, "fa-caret-right": a1 }; };
var _c4 = function (a0) { return { "ui-accordion-content-wrapper-overflown": a0 }; };
var _c5 = ["p-header", "*"];
var Accordion = /** @class */ (function () {
    function Accordion(el) {
        this.el = el;
        this.onClose = new core_1.EventEmitter();
        this.onOpen = new core_1.EventEmitter();
        this.tabs = [];
    }
    Accordion.prototype.addTab = function (tab) {
        this.tabs.push(tab);
    };
    Accordion.prototype.getBlockableElement = function () {
        return this.el.nativeElement.children[0];
    };
    Object.defineProperty(Accordion.prototype, "activeIndex", {
        get: function () {
            return this._activeIndex;
        },
        set: function (val) {
            this._activeIndex = val;
            if (this.tabs && this.tabs.length && this._activeIndex != null) {
                for (var i = 0; i < this.tabs.length; i++) {
                    var selected = this.multiple ? this._activeIndex.includes(i) : (i === this._activeIndex);
                    var changed = selected !== this.tabs[i].selected;
                    if (changed) {
                        this.tabs[i].animating = true;
                    }
                    this.tabs[i].selected = selected;
                    this.tabs[i].selectedChange.emit(selected);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Accordion.ɵfac = function Accordion_Factory(t) { return new (t || Accordion)(i0.ɵɵdirectiveInject(i0.ElementRef)); };
    Accordion.ɵcmp = i0.ɵɵdefineComponent({ type: Accordion, selectors: [["p-accordion"]], inputs: { multiple: "multiple", style: "style", styleClass: "styleClass", lazy: "lazy", activeIndex: "activeIndex" }, outputs: { onClose: "onClose", onOpen: "onOpen" }, ngContentSelectors: _c0, decls: 2, vars: 4, consts: [[3, "ngClass", "ngStyle"]], template: function Accordion_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵelementStart(0, "div", 0);
            i0.ɵɵprojection(1);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵclassMap(ctx.styleClass);
            i0.ɵɵproperty("ngClass", "ui-accordion ui-widget ui-helper-reset")("ngStyle", ctx.style);
        } }, directives: [i1.NgClass, i1.NgStyle], encapsulation: 2 });
    return Accordion;
}());
exports.Accordion = Accordion;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(Accordion, [{
        type: core_1.Component,
        args: [{
                selector: 'p-accordion',
                template: "\n        <div [ngClass]=\"'ui-accordion ui-widget ui-helper-reset'\" [ngStyle]=\"style\" [class]=\"styleClass\">\n            <ng-content></ng-content>\n        </div>\n    ",
            }]
    }], function () { return [{ type: i0.ElementRef }]; }, { multiple: [{
            type: core_1.Input
        }], onClose: [{
            type: core_1.Output
        }], onOpen: [{
            type: core_1.Output
        }], style: [{
            type: core_1.Input
        }], styleClass: [{
            type: core_1.Input
        }], lazy: [{
            type: core_1.Input
        }], activeIndex: [{
            type: core_1.Input
        }] }); })();
var AccordionTab = /** @class */ (function () {
    function AccordionTab(accordion) {
        this.accordion = accordion;
        this.selectedChange = new core_1.EventEmitter();
        this.accordion.addTab(this);
    }
    AccordionTab.prototype.toggle = function (event) {
        if (this.disabled || this.animating) {
            return false;
        }
        this.animating = true;
        var index = this.findTabIndex();
        if (this.selected) {
            this.selected = false;
            this.accordion.onClose.emit({ originalEvent: event, index: index });
        }
        else {
            if (!this.accordion.multiple) {
                for (var i = 0; i < this.accordion.tabs.length; i++) {
                    this.accordion.tabs[i].selected = false;
                    this.accordion.tabs[i].selectedChange.emit(false);
                }
            }
            this.selected = true;
            this.accordion.onOpen.emit({ originalEvent: event, index: index });
        }
        this.selectedChange.emit(this.selected);
        event.preventDefault();
    };
    AccordionTab.prototype.findTabIndex = function () {
        var index = -1;
        for (var i = 0; i < this.accordion.tabs.length; i++) {
            if (this.accordion.tabs[i] == this) {
                index = i;
                break;
            }
        }
        return index;
    };
    Object.defineProperty(AccordionTab.prototype, "lazy", {
        get: function () {
            return this.accordion.lazy;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AccordionTab.prototype, "hasHeaderFacet", {
        get: function () {
            return this.headerFacet && this.headerFacet.length > 0;
        },
        enumerable: true,
        configurable: true
    });
    AccordionTab.prototype.onToggleDone = function (event) {
        this.animating = false;
    };
    AccordionTab.prototype.ngOnDestroy = function () {
        this.accordion.tabs.splice(this.findTabIndex(), 1);
    };
    AccordionTab.ɵfac = function AccordionTab_Factory(t) { return new (t || AccordionTab)(i0.ɵɵdirectiveInject(Accordion)); };
    AccordionTab.ɵcmp = i0.ɵɵdefineComponent({ type: AccordionTab, selectors: [["p-accordionTab"]], contentQueries: function AccordionTab_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵcontentQuery(dirIndex, shared_1.Header, false);
        } if (rf & 2) {
            var _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.headerFacet = _t);
        } }, inputs: { header: "header", selected: "selected", disabled: "disabled" }, outputs: { selectedChange: "selectedChange" }, ngContentSelectors: _c5, decls: 6, vars: 16, consts: [[1, "ui-accordion-header", "ui-state-default", "ui-corner-all", 3, "ngClass", "click"], [1, "fa", "fa-fw", 3, "ngClass"], ["href", "#", "role", "tab", 4, "ngIf"], ["role", "tabpanel", 1, "ui-accordion-content-wrapper", 3, "ngClass"], ["class", "ui-accordion-content ui-widget-content", 4, "ngIf"], ["href", "#", "role", "tab"], [1, "ui-accordion-content", "ui-widget-content"]], template: function AccordionTab_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef(_c1);
            i0.ɵɵelementStart(0, "div", 0);
            i0.ɵɵlistener("click", function AccordionTab_Template_div_click_0_listener($event) { return ctx.toggle($event); });
            i0.ɵɵelement(1, "span", 1);
            i0.ɵɵtemplate(2, AccordionTab_a_2_Template, 2, 3, "a", 2);
            i0.ɵɵtemplate(3, AccordionTab_a_3_Template, 2, 2, "a", 2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(4, "div", 3);
            i0.ɵɵlistener("@tabContent.done", function AccordionTab_Template_div_animation_tabContent_done_4_listener($event) { return ctx.onToggleDone($event); });
            i0.ɵɵtemplate(5, AccordionTab_div_5_Template, 2, 0, "div", 4);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵproperty("ngClass", i0.ɵɵpureFunction2(8, _c2, ctx.selected, ctx.disabled));
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngClass", i0.ɵɵpureFunction2(11, _c3, ctx.selected, !ctx.selected));
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", !ctx.hasHeaderFacet);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.hasHeaderFacet);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("@tabContent", ctx.selected ? "visible" : "hidden")("ngClass", i0.ɵɵpureFunction1(14, _c4, !ctx.selected || ctx.animating));
            i0.ɵɵattribute("aria-hidden", !ctx.selected);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.lazy ? ctx.selected : true);
        } }, directives: [i1.NgClass, i1.NgIf], encapsulation: 2, data: { animation: [
                animations_1.trigger('tabContent', [
                    animations_1.state('hidden', animations_1.style({
                        height: '0'
                    })),
                    animations_1.state('visible', animations_1.style({
                        height: '*'
                    })),
                    animations_1.transition('visible <=> hidden', animations_1.animate('400ms cubic-bezier(0.86, 0, 0.07, 1)'))
                ])
            ] } });
    return AccordionTab;
}());
exports.AccordionTab = AccordionTab;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(AccordionTab, [{
        type: core_1.Component,
        args: [{
                selector: 'p-accordionTab',
                template: "\n        <div class=\"ui-accordion-header ui-state-default ui-corner-all\" [ngClass]=\"{'ui-state-active': selected,'ui-state-disabled':disabled}\"\n            (click)=\"toggle($event)\">\n            <span class=\"fa fa-fw\" [ngClass]=\"{'fa-caret-down': selected, 'fa-caret-right': !selected}\"></span>\n            <a href=\"#\" *ngIf=\"!hasHeaderFacet\" role=\"tab\" [attr.aria-expanded]=\"selected\" [attr.aria-selected]=\"selected\">{{header}}</a>\n            <a href=\"#\" *ngIf=\"hasHeaderFacet\" role=\"tab\" [attr.aria-expanded]=\"selected\" [attr.aria-selected]=\"selected\">\n                <ng-content select=\"p-header\"></ng-content>\n            </a>\n        </div>\n        <div class=\"ui-accordion-content-wrapper\" [@tabContent]=\"selected ? 'visible' : 'hidden'\" (@tabContent.done)=\"onToggleDone($event)\"\n            [ngClass]=\"{'ui-accordion-content-wrapper-overflown': !selected||animating}\" role=\"tabpanel\" [attr.aria-hidden]=\"!selected\">\n            <div class=\"ui-accordion-content ui-widget-content\" *ngIf=\"lazy ? selected : true\">\n                <ng-content></ng-content>\n            </div>\n        </div>\n    ",
                animations: [
                    animations_1.trigger('tabContent', [
                        animations_1.state('hidden', animations_1.style({
                            height: '0'
                        })),
                        animations_1.state('visible', animations_1.style({
                            height: '*'
                        })),
                        animations_1.transition('visible <=> hidden', animations_1.animate('400ms cubic-bezier(0.86, 0, 0.07, 1)'))
                    ])
                ]
            }]
    }], function () { return [{ type: Accordion }]; }, { header: [{
            type: core_1.Input
        }], selected: [{
            type: core_1.Input
        }], disabled: [{
            type: core_1.Input
        }], selectedChange: [{
            type: core_1.Output
        }], headerFacet: [{
            type: core_1.ContentChildren,
            args: [shared_1.Header]
        }] }); })();
var AccordionModule = /** @class */ (function () {
    function AccordionModule() {
    }
    AccordionModule.ɵmod = i0.ɵɵdefineNgModule({ type: AccordionModule });
    AccordionModule.ɵinj = i0.ɵɵdefineInjector({ factory: function AccordionModule_Factory(t) { return new (t || AccordionModule)(); }, imports: [[common_1.CommonModule]] });
    return AccordionModule;
}());
exports.AccordionModule = AccordionModule;
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(AccordionModule, { declarations: [Accordion,
        AccordionTab], imports: [common_1.CommonModule], exports: [Accordion,
        AccordionTab] }); })();
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(AccordionModule, [{
        type: core_1.NgModule,
        args: [{
                imports: [common_1.CommonModule],
                exports: [Accordion, AccordionTab],
                declarations: [Accordion, AccordionTab]
            }]
    }], null, null); })();
//# sourceMappingURL=accordion.js.map