"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var domhandler_1 = require("../dom/domhandler");
var i0 = require("@angular/core");
var i1 = require("../dom/domhandler");
var i2 = require("@angular/common");
var _c0 = ["mask"];
var _c1 = function (a0) { return { "ui-blockui-document": a0 }; };
var _c2 = function (a0) { return { display: a0 }; };
var _c3 = ["*"];
var BlockUI = /** @class */ (function () {
    function BlockUI(el, domHandler) {
        this.el = el;
        this.domHandler = domHandler;
        this.autoZIndex = true;
        this.baseZIndex = 0;
    }
    Object.defineProperty(BlockUI.prototype, "blocked", {
        get: function () {
            return this._blocked;
        },
        set: function (val) {
            this._blocked = val;
            if (this.mask.nativeElement) {
                if (this._blocked)
                    this.block();
                else
                    this.unblock();
            }
        },
        enumerable: true,
        configurable: true
    });
    BlockUI.prototype.ngAfterViewInit = function () {
        if (this.target && !this.target.getBlockableElement) {
            throw 'Target of BlockUI must implement BlockableUI interface';
        }
    };
    BlockUI.prototype.block = function () {
        if (this.target) {
            this.target.getBlockableElement().appendChild(this.mask.nativeElement);
            var style = this.target.style || {};
            style.position = 'relative';
            this.target.style = style;
        }
        else {
            document.body.appendChild(this.mask.nativeElement);
        }
        if (this.autoZIndex) {
            this.mask.nativeElement.style.zIndex = String(this.baseZIndex + (++domhandler_1.DomHandler.zindex));
        }
    };
    BlockUI.prototype.unblock = function () {
        this.el.nativeElement.appendChild(this.mask.nativeElement);
    };
    BlockUI.prototype.ngOnDestroy = function () {
        this.unblock();
    };
    BlockUI.ɵfac = function BlockUI_Factory(t) { return new (t || BlockUI)(i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i1.DomHandler)); };
    BlockUI.ɵcmp = i0.ɵɵdefineComponent({ type: BlockUI, selectors: [["p-blockUI"]], viewQuery: function BlockUI_Query(rf, ctx) { if (rf & 1) {
            i0.ɵɵstaticViewQuery(_c0, true);
        } if (rf & 2) {
            var _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.mask = _t.first);
        } }, inputs: { target: "target", autoZIndex: "autoZIndex", baseZIndex: "baseZIndex", blocked: "blocked" }, features: [i0.ɵɵProvidersFeature([domhandler_1.DomHandler])], ngContentSelectors: _c3, decls: 3, vars: 6, consts: [[1, "ui-blockui", "ui-widget-overlay", 3, "ngClass", "ngStyle"], ["mask", ""]], template: function BlockUI_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵelementStart(0, "div", 0, 1);
            i0.ɵɵprojection(2);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵproperty("ngClass", i0.ɵɵpureFunction1(2, _c1, !ctx.target))("ngStyle", i0.ɵɵpureFunction1(4, _c2, ctx.blocked ? "block" : "none"));
        } }, directives: [i2.NgClass, i2.NgStyle], encapsulation: 2 });
    return BlockUI;
}());
exports.BlockUI = BlockUI;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(BlockUI, [{
        type: core_1.Component,
        args: [{
                selector: 'p-blockUI',
                template: "\n        <div #mask class=\"ui-blockui ui-widget-overlay\" [ngClass]=\"{'ui-blockui-document':!target}\" [ngStyle]=\"{display: blocked ? 'block' : 'none'}\">\n            <ng-content></ng-content>\n        </div>\n    ",
                providers: [domhandler_1.DomHandler]
            }]
    }], function () { return [{ type: i0.ElementRef }, { type: i1.DomHandler }]; }, { target: [{
            type: core_1.Input
        }], autoZIndex: [{
            type: core_1.Input
        }], baseZIndex: [{
            type: core_1.Input
        }], mask: [{
            type: core_1.ViewChild,
            args: ['mask', { static: true }]
        }], blocked: [{
            type: core_1.Input
        }] }); })();
var BlockUIModule = /** @class */ (function () {
    function BlockUIModule() {
    }
    BlockUIModule.ɵmod = i0.ɵɵdefineNgModule({ type: BlockUIModule });
    BlockUIModule.ɵinj = i0.ɵɵdefineInjector({ factory: function BlockUIModule_Factory(t) { return new (t || BlockUIModule)(); }, imports: [[common_1.CommonModule]] });
    return BlockUIModule;
}());
exports.BlockUIModule = BlockUIModule;
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(BlockUIModule, { declarations: [BlockUI], imports: [common_1.CommonModule], exports: [BlockUI] }); })();
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(BlockUIModule, [{
        type: core_1.NgModule,
        args: [{
                imports: [common_1.CommonModule],
                exports: [BlockUI],
                declarations: [BlockUI]
            }]
    }], null, null); })();
//# sourceMappingURL=blockui.js.map