"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var i0 = require("@angular/core");
var Captcha = /** @class */ (function () {
    function Captcha(el, _zone) {
        this.el = el;
        this._zone = _zone;
        this.siteKey = null;
        this.theme = 'light';
        this.type = 'image';
        this.size = 'normal';
        this.tabindex = 0;
        this.language = null;
        this.initCallback = "initRecaptcha";
        this.onResponse = new core_1.EventEmitter();
        this.onExpire = new core_1.EventEmitter();
        this._instance = null;
    }
    Captcha.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (window.grecaptcha) {
            this.init();
        }
        else {
            window[this.initCallback] = function () {
                _this.init();
            };
        }
    };
    Captcha.prototype.init = function () {
        var _this = this;
        this._instance = window.grecaptcha.render(this.el.nativeElement.children[0], {
            'sitekey': this.siteKey,
            'theme': this.theme,
            'type': this.type,
            'size': this.size,
            'tabindex': this.tabindex,
            'hl': this.language,
            'callback': function (response) { _this._zone.run(function () { return _this.recaptchaCallback(response); }); },
            'expired-callback': function () { _this._zone.run(function () { return _this.recaptchaExpiredCallback(); }); }
        });
    };
    Captcha.prototype.reset = function () {
        if (this._instance === null)
            return;
        window.grecaptcha.reset(this._instance);
    };
    Captcha.prototype.getResponse = function () {
        if (this._instance === null)
            return null;
        return window.grecaptcha.getResponse(this._instance);
    };
    Captcha.prototype.recaptchaCallback = function (response) {
        this.onResponse.emit({
            response: response
        });
    };
    Captcha.prototype.recaptchaExpiredCallback = function () {
        this.onExpire.emit();
    };
    Captcha.prototype.ngOnDestroy = function () {
        if (this._instance != null) {
            window.grecaptcha.reset(this._instance);
        }
    };
    Captcha.ɵfac = function Captcha_Factory(t) { return new (t || Captcha)(i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i0.NgZone)); };
    Captcha.ɵcmp = i0.ɵɵdefineComponent({ type: Captcha, selectors: [["p-captcha"]], inputs: { siteKey: "siteKey", theme: "theme", type: "type", size: "size", tabindex: "tabindex", language: "language", initCallback: "initCallback" }, outputs: { onResponse: "onResponse", onExpire: "onExpire" }, decls: 1, vars: 0, template: function Captcha_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelement(0, "div");
        } }, encapsulation: 2 });
    return Captcha;
}());
exports.Captcha = Captcha;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(Captcha, [{
        type: core_1.Component,
        args: [{
                selector: 'p-captcha',
                template: "<div></div>"
            }]
    }], function () { return [{ type: i0.ElementRef }, { type: i0.NgZone }]; }, { siteKey: [{
            type: core_1.Input
        }], theme: [{
            type: core_1.Input
        }], type: [{
            type: core_1.Input
        }], size: [{
            type: core_1.Input
        }], tabindex: [{
            type: core_1.Input
        }], language: [{
            type: core_1.Input
        }], initCallback: [{
            type: core_1.Input
        }], onResponse: [{
            type: core_1.Output
        }], onExpire: [{
            type: core_1.Output
        }] }); })();
var CaptchaModule = /** @class */ (function () {
    function CaptchaModule() {
    }
    CaptchaModule.ɵmod = i0.ɵɵdefineNgModule({ type: CaptchaModule });
    CaptchaModule.ɵinj = i0.ɵɵdefineInjector({ factory: function CaptchaModule_Factory(t) { return new (t || CaptchaModule)(); }, imports: [[common_1.CommonModule]] });
    return CaptchaModule;
}());
exports.CaptchaModule = CaptchaModule;
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(CaptchaModule, { declarations: [Captcha], imports: [common_1.CommonModule], exports: [Captcha] }); })();
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(CaptchaModule, [{
        type: core_1.NgModule,
        args: [{
                imports: [common_1.CommonModule],
                exports: [Captcha],
                declarations: [Captcha]
            }]
    }], null, null); })();
//# sourceMappingURL=captcha.js.map