import { ElementRef, AfterViewInit, AfterViewChecked, EventEmitter, OnDestroy, TemplateRef, QueryList, Renderer2, ChangeDetectorRef } from '@angular/core';
import { DomHandler } from '../dom/domhandler';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
import * as i2 from "../common/shared";
export declare class Carousel implements AfterViewChecked, AfterViewInit, OnDestroy {
    el: ElementRef;
    domHandler: DomHandler;
    renderer: Renderer2;
    cd: ChangeDetectorRef;
    numVisible: number;
    firstVisible: number;
    headerText: string;
    circular: boolean;
    breakpoint: number;
    responsive: boolean;
    autoplayInterval: number;
    effectDuration: any;
    easing: string;
    pageLinks: number;
    style: any;
    styleClass: string;
    onPage: EventEmitter<any>;
    templates: QueryList<any>;
    _value: any[];
    itemTemplate: TemplateRef<any>;
    left: any;
    items: any;
    columns: any;
    page: number;
    valuesChanged: any;
    interval: any;
    anchorPageLinks: any[];
    mobileDropdownOptions: any[];
    selectDropdownOptions: any[];
    shrinked: boolean;
    containerViewChild: ElementRef;
    viewportViewChild: ElementRef;
    itemsViewChild: ElementRef;
    documentResponsiveListener: any;
    differ: any;
    constructor(el: ElementRef, domHandler: DomHandler, renderer: Renderer2, cd: ChangeDetectorRef);
    ngAfterContentInit(): void;
    get value(): any[];
    set value(val: any[]);
    handleDataChange(): void;
    ngAfterViewChecked(): void;
    ngAfterViewInit(): void;
    updateLinks(): void;
    updateDropdown(): void;
    updateMobileDropdown(): void;
    render(): void;
    calculateItemWidths(): void;
    calculateColumns(): void;
    onNextNav(): void;
    onPrevNav(): void;
    setPageWithLink(event: any, p: number): void;
    setPage(p: any, enforce?: boolean): void;
    onDropdownChange(val: string): void;
    get displayPageLinks(): boolean;
    get displayPageDropdown(): boolean;
    get totalPages(): number;
    routerDisplay(): boolean;
    updateState(): void;
    startAutoplay(): void;
    stopAutoplay(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDef<Carousel, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<Carousel, "p-carousel", never, { "numVisible": "numVisible"; "firstVisible": "firstVisible"; "headerText": "headerText"; "circular": "circular"; "breakpoint": "breakpoint"; "responsive": "responsive"; "autoplayInterval": "autoplayInterval"; "effectDuration": "effectDuration"; "easing": "easing"; "pageLinks": "pageLinks"; "style": "style"; "styleClass": "styleClass"; "value": "value"; }, { "onPage": "onPage"; }, ["templates"], never>;
}
export declare class CarouselModule {
    static ɵmod: i0.ɵɵNgModuleDefWithMeta<CarouselModule, [typeof Carousel], [typeof i1.CommonModule, typeof i2.SharedModule], [typeof Carousel, typeof i2.SharedModule]>;
    static ɵinj: i0.ɵɵInjectorDef<CarouselModule>;
}
