"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var i0 = require("@angular/core");
var UIChart = /** @class */ (function () {
    function UIChart(el) {
        this.el = el;
        this.onDataSelect = new core_1.EventEmitter();
    }
    Object.defineProperty(UIChart.prototype, "data", {
        get: function () {
            return this._data;
        },
        set: function (val) {
            this._data = val;
            this.reinit();
        },
        enumerable: true,
        configurable: true
    });
    UIChart.prototype.ngAfterViewInit = function () {
        this.initChart();
        this.initialized = true;
    };
    UIChart.prototype.onCanvasClick = function (event) {
        if (this.chart) {
            var element = this.chart.getElementAtEvent(event);
            var dataset = this.chart.getDatasetAtEvent(event);
            if (element && element[0] && dataset) {
                this.onDataSelect.emit({ originalEvent: event, element: element[0], dataset: dataset });
            }
        }
    };
    UIChart.prototype.initChart = function () {
        this.chart = new Chart(this.el.nativeElement.children[0].children[0], {
            type: this.type,
            data: this.data,
            options: this.options
        });
    };
    UIChart.prototype.getCanvas = function () {
        return this.el.nativeElement.children[0].children[0];
    };
    UIChart.prototype.getBase64Image = function () {
        return this.chart.toBase64Image();
    };
    UIChart.prototype.generateLegend = function () {
        if (this.chart) {
            this.chart.generateLegend();
        }
    };
    UIChart.prototype.refresh = function () {
        if (this.chart) {
            this.chart.update();
        }
    };
    UIChart.prototype.reinit = function () {
        if (this.chart) {
            this.chart.destroy();
            this.initChart();
        }
    };
    UIChart.prototype.ngOnDestroy = function () {
        if (this.chart) {
            this.chart.destroy();
            this.initialized = false;
            this.chart = null;
        }
    };
    UIChart.ɵfac = function UIChart_Factory(t) { return new (t || UIChart)(i0.ɵɵdirectiveInject(i0.ElementRef)); };
    UIChart.ɵcmp = i0.ɵɵdefineComponent({ type: UIChart, selectors: [["p-chart"]], inputs: { type: "type", options: "options", width: "width", height: "height", data: "data" }, outputs: { onDataSelect: "onDataSelect" }, decls: 2, vars: 2, consts: [[3, "click"]], template: function UIChart_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "div");
            i0.ɵɵelementStart(1, "canvas", 0);
            i0.ɵɵlistener("click", function UIChart_Template_canvas_click_1_listener($event) { return ctx.onCanvasClick($event); });
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵattribute("width", ctx.width)("height", ctx.height);
        } }, encapsulation: 2 });
    return UIChart;
}());
exports.UIChart = UIChart;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(UIChart, [{
        type: core_1.Component,
        args: [{
                selector: 'p-chart',
                template: "\n        <div>\n            <canvas [attr.width]=\"width\" [attr.height]=\"height\" (click)=\"onCanvasClick($event)\"></canvas>\n        </div>\n    "
            }]
    }], function () { return [{ type: i0.ElementRef }]; }, { type: [{
            type: core_1.Input
        }], options: [{
            type: core_1.Input
        }], width: [{
            type: core_1.Input
        }], height: [{
            type: core_1.Input
        }], onDataSelect: [{
            type: core_1.Output
        }], data: [{
            type: core_1.Input
        }] }); })();
var ChartModule = /** @class */ (function () {
    function ChartModule() {
    }
    ChartModule.ɵmod = i0.ɵɵdefineNgModule({ type: ChartModule });
    ChartModule.ɵinj = i0.ɵɵdefineInjector({ factory: function ChartModule_Factory(t) { return new (t || ChartModule)(); }, imports: [[common_1.CommonModule]] });
    return ChartModule;
}());
exports.ChartModule = ChartModule;
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(ChartModule, { declarations: [UIChart], imports: [common_1.CommonModule], exports: [UIChart] }); })();
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(ChartModule, [{
        type: core_1.NgModule,
        args: [{
                imports: [common_1.CommonModule],
                exports: [UIChart],
                declarations: [UIChart]
            }]
    }], null, null); })();
//# sourceMappingURL=chart.js.map