"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var i0 = require("@angular/core");
var i1 = require("@angular/common");
var _c0 = function (a0, a1, a2) { return { "ui-label-active": a0, "ui-label-disabled": a1, "ui-label-focus": a2 }; };
function Checkbox_label_6_Template(rf, ctx) { if (rf & 1) {
    var _r3 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "label", 7);
    i0.ɵɵlistener("click", function Checkbox_label_6_Template_label_click_0_listener($event) { i0.ɵɵrestoreView(_r3); var ctx_r2 = i0.ɵɵnextContext(); var _r0 = i0.ɵɵreference(3); return ctx_r2.onClick($event, _r0, true); });
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    var ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵproperty("ngClass", i0.ɵɵpureFunction3(3, _c0, ctx_r1.checked, ctx_r1.disabled, ctx_r1.focused));
    i0.ɵɵattribute("for", ctx_r1.inputId);
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(ctx_r1.label);
} }
var _c1 = function (a0) { return { "ui-state-focus": a0 }; };
var _c2 = function (a0, a1, a2) { return { "ui-state-active": a0, "ui-state-disabled": a1, "ui-state-focus": a2 }; };
var _c3 = function (a0) { return { "fa fa-check": a0 }; };
exports.CHECKBOX_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return Checkbox; }),
    multi: true
};
var Checkbox = /** @class */ (function () {
    function Checkbox(cd) {
        this.cd = cd;
        this.onChange = new core_1.EventEmitter();
        this.onModelChange = function () { };
        this.onModelTouched = function () { };
        this.focused = false;
        this.checked = false;
    }
    Checkbox.prototype.onClick = function (event, checkbox, focus) {
        event.preventDefault();
        if (this.disabled) {
            return;
        }
        this.checked = !this.checked;
        this.updateModel();
        if (focus) {
            checkbox.focus();
        }
    };
    Checkbox.prototype.updateModel = function () {
        if (!this.binary) {
            if (this.checked)
                this.addValue();
            else
                this.removeValue();
            this.onModelChange(this.model);
            if (this.formControl) {
                this.formControl.setValue(this.model);
            }
        }
        else {
            this.onModelChange(this.checked);
        }
        this.onChange.emit(this.checked);
    };
    Checkbox.prototype.handleChange = function (event) {
        this.checked = event.target.checked;
        this.updateModel();
    };
    Checkbox.prototype.isChecked = function () {
        if (this.binary)
            return this.model;
        else
            return this.model && this.model.indexOf(this.value) > -1;
    };
    Checkbox.prototype.removeValue = function () {
        var _this = this;
        this.model = this.model.filter(function (val) { return val !== _this.value; });
    };
    Checkbox.prototype.addValue = function () {
        if (this.model)
            this.model = __spreadArrays(this.model, [this.value]);
        else
            this.model = [this.value];
    };
    Checkbox.prototype.onFocus = function (event) {
        this.focused = true;
    };
    Checkbox.prototype.onBlur = function (event) {
        this.focused = false;
        this.onModelTouched();
    };
    Checkbox.prototype.writeValue = function (model) {
        this.model = model;
        this.checked = this.isChecked();
        this.cd.markForCheck();
    };
    Checkbox.prototype.registerOnChange = function (fn) {
        this.onModelChange = fn;
    };
    Checkbox.prototype.registerOnTouched = function (fn) {
        this.onModelTouched = fn;
    };
    Checkbox.prototype.setDisabledState = function (val) {
        this.disabled = val;
    };
    Checkbox.ɵfac = function Checkbox_Factory(t) { return new (t || Checkbox)(i0.ɵɵdirectiveInject(i0.ChangeDetectorRef)); };
    Checkbox.ɵcmp = i0.ɵɵdefineComponent({ type: Checkbox, selectors: [["p-checkbox"]], inputs: { value: "value", name: "name", disabled: "disabled", binary: "binary", label: "label", tabindex: "tabindex", inputId: "inputId", style: "style", styleClass: "styleClass", formControl: "formControl" }, outputs: { onChange: "onChange" }, features: [i0.ɵɵProvidersFeature([exports.CHECKBOX_VALUE_ACCESSOR])], decls: 7, vars: 22, consts: [[3, "ngStyle", "ngClass"], [1, "ui-helper-hidden-accessible"], ["type", "checkbox", 3, "name", "value", "checked", "ngClass", "disabled", "focus", "blur", "change"], ["cb", ""], [1, "ui-chkbox-box", "ui-widget", "ui-corner-all", "ui-state-default", 3, "ngClass", "click"], [1, "ui-chkbox-icon", "ui-clickable", 3, "ngClass"], ["class", "ui-chkbox-label", 3, "ngClass", "click", 4, "ngIf"], [1, "ui-chkbox-label", 3, "ngClass", "click"]], template: function Checkbox_Template(rf, ctx) { if (rf & 1) {
            var _r4 = i0.ɵɵgetCurrentView();
            i0.ɵɵelementStart(0, "div", 0);
            i0.ɵɵelementStart(1, "div", 1);
            i0.ɵɵelementStart(2, "input", 2, 3);
            i0.ɵɵlistener("focus", function Checkbox_Template_input_focus_2_listener($event) { return ctx.onFocus($event); })("blur", function Checkbox_Template_input_blur_2_listener($event) { return ctx.onBlur($event); })("change", function Checkbox_Template_input_change_2_listener($event) { return ctx.handleChange($event); });
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(4, "div", 4);
            i0.ɵɵlistener("click", function Checkbox_Template_div_click_4_listener($event) { i0.ɵɵrestoreView(_r4); var _r0 = i0.ɵɵreference(3); return ctx.onClick($event, _r0, true); });
            i0.ɵɵelement(5, "span", 5);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵtemplate(6, Checkbox_label_6_Template, 2, 7, "label", 6);
        } if (rf & 2) {
            i0.ɵɵclassMap(ctx.styleClass);
            i0.ɵɵproperty("ngStyle", ctx.style)("ngClass", "ui-chkbox ui-widget");
            i0.ɵɵadvance(2);
            i0.ɵɵproperty("name", ctx.name)("value", ctx.value)("checked", ctx.checked)("ngClass", i0.ɵɵpureFunction1(14, _c1, ctx.focused))("disabled", ctx.disabled);
            i0.ɵɵattribute("id", ctx.inputId)("tabindex", ctx.tabindex);
            i0.ɵɵadvance(2);
            i0.ɵɵproperty("ngClass", i0.ɵɵpureFunction3(16, _c2, ctx.checked, ctx.disabled, ctx.focused));
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngClass", i0.ɵɵpureFunction1(20, _c3, ctx.checked));
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.label);
        } }, directives: [i1.NgStyle, i1.NgClass, i1.NgIf], encapsulation: 2 });
    return Checkbox;
}());
exports.Checkbox = Checkbox;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(Checkbox, [{
        type: core_1.Component,
        args: [{
                selector: 'p-checkbox',
                template: "\n        <div [ngStyle]=\"style\" [ngClass]=\"'ui-chkbox ui-widget'\" [class]=\"styleClass\">\n            <div class=\"ui-helper-hidden-accessible\">\n                <input #cb type=\"checkbox\" [attr.id]=\"inputId\" [name]=\"name\" [value]=\"value\" [checked]=\"checked\" (focus)=\"onFocus($event)\" (blur)=\"onBlur($event)\"\n                [ngClass]=\"{'ui-state-focus':focused}\" (change)=\"handleChange($event)\" [disabled]=\"disabled\" [attr.tabindex]=\"tabindex\">\n            </div>\n            <div class=\"ui-chkbox-box ui-widget ui-corner-all ui-state-default\" (click)=\"onClick($event,cb,true)\"\n                        [ngClass]=\"{'ui-state-active':checked,'ui-state-disabled':disabled,'ui-state-focus':focused}\">\n                <span class=\"ui-chkbox-icon ui-clickable\" [ngClass]=\"{'fa fa-check':checked}\"></span>\n            </div>\n        </div>\n        <label class=\"ui-chkbox-label\" (click)=\"onClick($event,cb,true)\" \n                [ngClass]=\"{'ui-label-active':checked, 'ui-label-disabled':disabled, 'ui-label-focus':focused}\"\n                *ngIf=\"label\" [attr.for]=\"inputId\">{{label}}</label>\n    ",
                providers: [exports.CHECKBOX_VALUE_ACCESSOR]
            }]
    }], function () { return [{ type: i0.ChangeDetectorRef }]; }, { value: [{
            type: core_1.Input
        }], name: [{
            type: core_1.Input
        }], disabled: [{
            type: core_1.Input
        }], binary: [{
            type: core_1.Input
        }], label: [{
            type: core_1.Input
        }], tabindex: [{
            type: core_1.Input
        }], inputId: [{
            type: core_1.Input
        }], style: [{
            type: core_1.Input
        }], styleClass: [{
            type: core_1.Input
        }], formControl: [{
            type: core_1.Input
        }], onChange: [{
            type: core_1.Output
        }] }); })();
var CheckboxModule = /** @class */ (function () {
    function CheckboxModule() {
    }
    CheckboxModule.ɵmod = i0.ɵɵdefineNgModule({ type: CheckboxModule });
    CheckboxModule.ɵinj = i0.ɵɵdefineInjector({ factory: function CheckboxModule_Factory(t) { return new (t || CheckboxModule)(); }, imports: [[common_1.CommonModule]] });
    return CheckboxModule;
}());
exports.CheckboxModule = CheckboxModule;
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(CheckboxModule, { declarations: [Checkbox], imports: [common_1.CommonModule], exports: [Checkbox] }); })();
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(CheckboxModule, [{
        type: core_1.NgModule,
        args: [{
                imports: [common_1.CommonModule],
                exports: [Checkbox],
                declarations: [Checkbox]
            }]
    }], null, null); })();
//# sourceMappingURL=checkbox.js.map