import { ElementRef, EventEmitter, AfterContentInit, QueryList, TemplateRef } from '@angular/core';
import { DomHandler } from '../dom/domhandler';
import { ControlValueAccessor } from '@angular/forms';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
import * as i2 from "../inputtext/inputtext";
import * as i3 from "../common/shared";
export declare const CHIPS_VALUE_ACCESSOR: any;
export declare class Chips implements AfterContentInit, ControlValueAccessor {
    el: ElementRef;
    domHandler: DomHandler;
    style: any;
    styleClass: string;
    disabled: boolean;
    onAdd: EventEmitter<any>;
    onRemove: EventEmitter<any>;
    field: string;
    placeholder: string;
    max: number;
    tabindex: number;
    inputId: string;
    allowDuplicate: boolean;
    inputStyle: any;
    inputStyleClass: any;
    addOnTab: boolean;
    addOnBlur: boolean;
    onFocus: EventEmitter<any>;
    onBlur: EventEmitter<any>;
    templates: QueryList<any>;
    itemTemplate: TemplateRef<any>;
    value: any;
    onModelChange: Function;
    onModelTouched: Function;
    valueChanged: boolean;
    focus: boolean;
    constructor(el: ElementRef, domHandler: DomHandler);
    ngAfterContentInit(): void;
    writeValue(value: any): void;
    registerOnChange(fn: Function): void;
    registerOnTouched(fn: Function): void;
    setDisabledState(val: boolean): void;
    resolveFieldData(data: any, field: string): any;
    onInputFocus(): void;
    onInputBlur(event: FocusEvent, inputEL: HTMLInputElement): void;
    removeItem(event: Event, index: number): void;
    addItem(event: Event, item: string): void;
    onKeydown(event: KeyboardEvent, inputEL: HTMLInputElement): void;
    get maxedOut(): boolean;
    static ɵfac: i0.ɵɵFactoryDef<Chips, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<Chips, "p-chips", never, { "style": "style"; "styleClass": "styleClass"; "disabled": "disabled"; "field": "field"; "placeholder": "placeholder"; "max": "max"; "tabindex": "tabindex"; "inputId": "inputId"; "allowDuplicate": "allowDuplicate"; "inputStyle": "inputStyle"; "inputStyleClass": "inputStyleClass"; "addOnTab": "addOnTab"; "addOnBlur": "addOnBlur"; }, { "onAdd": "onAdd"; "onRemove": "onRemove"; "onFocus": "onFocus"; "onBlur": "onBlur"; }, ["templates"], never>;
}
export declare class ChipsModule {
    static ɵmod: i0.ɵɵNgModuleDefWithMeta<ChipsModule, [typeof Chips], [typeof i1.CommonModule, typeof i2.InputTextModule, typeof i3.SharedModule], [typeof Chips, typeof i2.InputTextModule, typeof i3.SharedModule]>;
    static ɵinj: i0.ɵɵInjectorDef<ChipsModule>;
}
