import { EventEmitter, ViewContainerRef, TemplateRef, OnInit, OnChanges, OnDestroy, AfterContentInit, QueryList, SimpleChanges, EmbeddedViewRef } from '@angular/core';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
export declare class Header {
    static ɵfac: i0.ɵɵFactoryDef<Header, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<Header, "p-header", never, {}, {}, never, ["*"]>;
}
export declare class Footer {
    static ɵfac: i0.ɵɵFactoryDef<Footer, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<Footer, "p-footer", never, {}, {}, never, ["*"]>;
}
export declare class PrimeTemplate {
    template: TemplateRef<any>;
    type: string;
    name: string;
    constructor(template: TemplateRef<any>);
    getType(): string;
    static ɵfac: i0.ɵɵFactoryDef<PrimeTemplate, never>;
    static ɵdir: i0.ɵɵDirectiveDefWithMeta<PrimeTemplate, "[pTemplate]", never, { "type": "type"; "name": "pTemplate"; }, {}, never>;
}
export declare class TemplateWrapper implements OnInit, OnDestroy {
    viewContainer: ViewContainerRef;
    item: any;
    index: number;
    templateRef: TemplateRef<any>;
    view: EmbeddedViewRef<any>;
    constructor(viewContainer: ViewContainerRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDef<TemplateWrapper, never>;
    static ɵdir: i0.ɵɵDirectiveDefWithMeta<TemplateWrapper, "[pTemplateWrapper]", never, { "item": "item"; "index": "index"; "templateRef": "pTemplateWrapper"; }, {}, never>;
}
export declare class Column implements AfterContentInit {
    field: string;
    colId: string;
    sortField: string;
    filterField: string;
    header: string;
    footer: string;
    sortable: any;
    editable: boolean;
    filter: boolean;
    filterMatchMode: string;
    filterType: string;
    excludeGlobalFilter: boolean;
    rowspan: number;
    colspan: number;
    scope: string;
    style: any;
    styleClass: string;
    exportable: boolean;
    headerStyle: any;
    headerStyleClass: string;
    bodyStyle: any;
    bodyStyleClass: string;
    footerStyle: any;
    footerStyleClass: string;
    hidden: boolean;
    expander: boolean;
    selectionMode: string;
    filterPlaceholder: string;
    filterMaxlength: number;
    frozen: boolean;
    sortFunction: EventEmitter<any>;
    templates: QueryList<any>;
    template: TemplateRef<any>;
    headerTemplate: TemplateRef<any>;
    bodyTemplate: TemplateRef<any>;
    footerTemplate: TemplateRef<any>;
    filterTemplate: TemplateRef<any>;
    editorTemplate: TemplateRef<any>;
    ngAfterContentInit(): void;
    static ɵfac: i0.ɵɵFactoryDef<Column, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<Column, "p-column", never, { "field": "field"; "colId": "colId"; "sortField": "sortField"; "filterField": "filterField"; "header": "header"; "footer": "footer"; "sortable": "sortable"; "editable": "editable"; "filter": "filter"; "filterMatchMode": "filterMatchMode"; "filterType": "filterType"; "excludeGlobalFilter": "excludeGlobalFilter"; "rowspan": "rowspan"; "colspan": "colspan"; "scope": "scope"; "style": "style"; "styleClass": "styleClass"; "exportable": "exportable"; "headerStyle": "headerStyle"; "headerStyleClass": "headerStyleClass"; "bodyStyle": "bodyStyle"; "bodyStyleClass": "bodyStyleClass"; "footerStyle": "footerStyle"; "footerStyleClass": "footerStyleClass"; "hidden": "hidden"; "expander": "expander"; "selectionMode": "selectionMode"; "filterPlaceholder": "filterPlaceholder"; "filterMaxlength": "filterMaxlength"; "frozen": "frozen"; }, { "sortFunction": "sortFunction"; }, ["template", "templates"], never>;
}
export declare class Row {
    columns: QueryList<Column>;
    static ɵfac: i0.ɵɵFactoryDef<Row, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<Row, "p-row", never, {}, {}, ["columns"], never>;
}
export declare class HeaderColumnGroup {
    frozen: boolean;
    rows: QueryList<any>;
    static ɵfac: i0.ɵɵFactoryDef<HeaderColumnGroup, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<HeaderColumnGroup, "p-headerColumnGroup", never, { "frozen": "frozen"; }, {}, ["rows"], never>;
}
export declare class FooterColumnGroup {
    frozen: boolean;
    rows: QueryList<any>;
    static ɵfac: i0.ɵɵFactoryDef<FooterColumnGroup, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<FooterColumnGroup, "p-footerColumnGroup", never, { "frozen": "frozen"; }, {}, ["rows"], never>;
}
export declare class ColumnBodyTemplateLoader implements OnInit, OnChanges, OnDestroy {
    viewContainer: ViewContainerRef;
    column: any;
    rowData: any;
    rowIndex: number;
    view: EmbeddedViewRef<any>;
    constructor(viewContainer: ViewContainerRef);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDef<ColumnBodyTemplateLoader, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<ColumnBodyTemplateLoader, "p-columnBodyTemplateLoader", never, { "column": "column"; "rowData": "rowData"; "rowIndex": "rowIndex"; }, {}, never, never>;
}
export declare class ColumnHeaderTemplateLoader implements OnInit, OnDestroy {
    viewContainer: ViewContainerRef;
    column: any;
    view: EmbeddedViewRef<any>;
    constructor(viewContainer: ViewContainerRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDef<ColumnHeaderTemplateLoader, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<ColumnHeaderTemplateLoader, "p-columnHeaderTemplateLoader", never, { "column": "column"; }, {}, never, never>;
}
export declare class ColumnFooterTemplateLoader implements OnInit, OnDestroy {
    viewContainer: ViewContainerRef;
    column: any;
    view: EmbeddedViewRef<any>;
    constructor(viewContainer: ViewContainerRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDef<ColumnFooterTemplateLoader, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<ColumnFooterTemplateLoader, "p-columnFooterTemplateLoader", never, { "column": "column"; }, {}, never, never>;
}
export declare class ColumnFilterTemplateLoader implements OnInit, OnDestroy {
    viewContainer: ViewContainerRef;
    column: any;
    view: EmbeddedViewRef<any>;
    constructor(viewContainer: ViewContainerRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDef<ColumnFilterTemplateLoader, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<ColumnFilterTemplateLoader, "p-columnFilterTemplateLoader", never, { "column": "column"; }, {}, never, never>;
}
export declare class ColumnEditorTemplateLoader implements OnInit, OnDestroy {
    viewContainer: ViewContainerRef;
    column: any;
    rowData: any;
    rowIndex: any;
    view: EmbeddedViewRef<any>;
    constructor(viewContainer: ViewContainerRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDef<ColumnEditorTemplateLoader, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<ColumnEditorTemplateLoader, "p-columnEditorTemplateLoader", never, { "column": "column"; "rowData": "rowData"; "rowIndex": "rowIndex"; }, {}, never, never>;
}
export declare class TemplateLoader implements OnInit, OnDestroy {
    viewContainer: ViewContainerRef;
    template: TemplateRef<any>;
    data: any;
    view: EmbeddedViewRef<any>;
    constructor(viewContainer: ViewContainerRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDef<TemplateLoader, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<TemplateLoader, "p-templateLoader", never, { "template": "template"; "data": "data"; }, {}, never, never>;
}
export declare class SharedModule {
    static ɵmod: i0.ɵɵNgModuleDefWithMeta<SharedModule, [typeof Header, typeof Footer, typeof Column, typeof TemplateWrapper, typeof ColumnHeaderTemplateLoader, typeof ColumnBodyTemplateLoader, typeof ColumnFooterTemplateLoader, typeof ColumnFilterTemplateLoader, typeof PrimeTemplate, typeof TemplateLoader, typeof Row, typeof HeaderColumnGroup, typeof FooterColumnGroup, typeof ColumnEditorTemplateLoader], [typeof i1.CommonModule], [typeof Header, typeof Footer, typeof Column, typeof TemplateWrapper, typeof ColumnHeaderTemplateLoader, typeof ColumnBodyTemplateLoader, typeof ColumnFooterTemplateLoader, typeof ColumnFilterTemplateLoader, typeof PrimeTemplate, typeof TemplateLoader, typeof Row, typeof HeaderColumnGroup, typeof FooterColumnGroup, typeof ColumnEditorTemplateLoader]>;
    static ɵinj: i0.ɵɵInjectorDef<SharedModule>;
}
