import { ElementRef, AfterViewInit, OnDestroy, AfterViewChecked, Renderer2, NgZone } from '@angular/core';
import { DomHandler } from '../dom/domhandler';
import { Confirmation } from '../common/confirmation';
import { ConfirmationService } from '../common/confirmationservice';
import { Subscription } from 'rxjs';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
import * as i2 from "../button/button";
import * as i3 from "../common/shared";
export declare class ConfirmDialog implements AfterViewInit, AfterViewChecked, OnDestroy {
    el: ElementRef;
    domHandler: DomHandler;
    renderer: Renderer2;
    private confirmationService;
    zone: NgZone;
    header: string;
    icon: string;
    message: string;
    acceptIcon: string;
    acceptLabel: string;
    acceptVisible: boolean;
    rejectIcon: string;
    rejectLabel: string;
    rejectVisible: boolean;
    width: any;
    height: any;
    closeOnEscape: boolean;
    rtl: boolean;
    closable: boolean;
    responsive: boolean;
    appendTo: any;
    key: string;
    footer: any;
    confirmation: Confirmation;
    _visible: boolean;
    documentEscapeListener: any;
    documentResponsiveListener: any;
    mask: any;
    contentContainer: any;
    positionInitialized: boolean;
    subscription: Subscription;
    executePostShowActions: boolean;
    constructor(el: ElementRef, domHandler: DomHandler, renderer: Renderer2, confirmationService: ConfirmationService, zone: NgZone);
    get visible(): boolean;
    set visible(val: boolean);
    ngAfterViewInit(): void;
    ngAfterViewChecked(): void;
    center(): void;
    enableModality(): void;
    disableModality(): void;
    close(event: Event): void;
    hide(): void;
    moveOnTop(): void;
    bindGlobalListeners(): void;
    unbindGlobalListeners(): void;
    ngOnDestroy(): void;
    accept(): void;
    reject(): void;
    static ɵfac: i0.ɵɵFactoryDef<ConfirmDialog, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<ConfirmDialog, "p-confirmDialog", never, { "header": "header"; "icon": "icon"; "message": "message"; "acceptIcon": "acceptIcon"; "acceptLabel": "acceptLabel"; "acceptVisible": "acceptVisible"; "rejectIcon": "rejectIcon"; "rejectLabel": "rejectLabel"; "rejectVisible": "rejectVisible"; "width": "width"; "height": "height"; "closeOnEscape": "closeOnEscape"; "rtl": "rtl"; "closable": "closable"; "responsive": "responsive"; "appendTo": "appendTo"; "key": "key"; "visible": "visible"; }, {}, ["footer"], ["p-footer"]>;
}
export declare class ConfirmDialogModule {
    static ɵmod: i0.ɵɵNgModuleDefWithMeta<ConfirmDialogModule, [typeof ConfirmDialog], [typeof i1.CommonModule, typeof i2.ButtonModule], [typeof ConfirmDialog, typeof i2.ButtonModule, typeof i3.SharedModule]>;
    static ɵinj: i0.ɵɵInjectorDef<ConfirmDialogModule>;
}
