"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var shared_1 = require("../common/shared");
var paginator_1 = require("../paginator/paginator");
var i0 = require("@angular/core");
var i1 = require("@angular/common");
var i2 = require("../paginator/paginator");
function DataGrid_div_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 8);
    i0.ɵɵprojection(1);
    i0.ɵɵelementEnd();
} }
function DataGrid_p_paginator_2_Template(rf, ctx) { if (rf & 1) {
    var _r7 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "p-paginator", 9);
    i0.ɵɵlistener("onPageChange", function DataGrid_p_paginator_2_Template_p_paginator_onPageChange_0_listener($event) { i0.ɵɵrestoreView(_r7); var ctx_r6 = i0.ɵɵnextContext(); return ctx_r6.paginate($event); });
    i0.ɵɵelementEnd();
} if (rf & 2) {
    var ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵproperty("rows", ctx_r1.rows)("first", ctx_r1.first)("totalRecords", ctx_r1.totalRecords)("pageLinkSize", ctx_r1.pageLinks)("alwaysShow", ctx_r1.alwaysShowPaginator)("rowsPerPageOptions", ctx_r1.rowsPerPageOptions);
} }
function DataGrid_ng_template_5_Template(rf, ctx) { }
function DataGrid_div_6_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 10);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    var ctx_r3 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(ctx_r3.emptyMessage);
} }
function DataGrid_p_paginator_7_Template(rf, ctx) { if (rf & 1) {
    var _r9 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "p-paginator", 9);
    i0.ɵɵlistener("onPageChange", function DataGrid_p_paginator_7_Template_p_paginator_onPageChange_0_listener($event) { i0.ɵɵrestoreView(_r9); var ctx_r8 = i0.ɵɵnextContext(); return ctx_r8.paginate($event); });
    i0.ɵɵelementEnd();
} if (rf & 2) {
    var ctx_r4 = i0.ɵɵnextContext();
    i0.ɵɵproperty("rows", ctx_r4.rows)("first", ctx_r4.first)("totalRecords", ctx_r4.totalRecords)("pageLinkSize", ctx_r4.pageLinks)("alwaysShow", ctx_r4.alwaysShowPaginator)("rowsPerPageOptions", ctx_r4.rowsPerPageOptions);
} }
function DataGrid_div_8_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 11);
    i0.ɵɵprojection(1, 1);
    i0.ɵɵelementEnd();
} }
var _c0 = [[["p-header"]], [["p-footer"]]];
var _c1 = ["p-header", "p-footer"];
var DataGrid = /** @class */ (function () {
    function DataGrid(el, differs) {
        this.el = el;
        this.differs = differs;
        this.pageLinks = 5;
        this.emptyMessage = 'No records found';
        this.onLazyLoad = new core_1.EventEmitter();
        this.paginatorPosition = 'bottom';
        this.alwaysShowPaginator = true;
        this.trackBy = function (index, item) { return item; };
        this.immutable = true;
        this.onPage = new core_1.EventEmitter();
        this.first = 0;
        this.page = 0;
        this.differ = differs.find([]).create(null);
    }
    DataGrid.prototype.ngAfterViewInit = function () {
        if (this.lazy) {
            this.onLazyLoad.emit({
                first: this.first,
                rows: this.rows
            });
        }
    };
    DataGrid.prototype.ngAfterContentInit = function () {
        var _this = this;
        this.templates.forEach(function (item) {
            switch (item.getType()) {
                case 'item':
                    _this.itemTemplate = item.template;
                    break;
                default:
                    _this.itemTemplate = item.template;
                    break;
            }
        });
    };
    Object.defineProperty(DataGrid.prototype, "value", {
        get: function () {
            return this._value;
        },
        set: function (val) {
            this._value = val;
            if (this.immutable) {
                this.handleDataChange();
            }
        },
        enumerable: true,
        configurable: true
    });
    DataGrid.prototype.handleDataChange = function () {
        if (this.paginator) {
            this.updatePaginator();
        }
        this.updateDataToRender(this.value);
    };
    DataGrid.prototype.ngDoCheck = function () {
        if (!this.immutable) {
            var changes = this.differ.diff(this.value);
            if (changes) {
                this.handleDataChange();
            }
        }
    };
    DataGrid.prototype.updatePaginator = function () {
        //total records
        this.totalRecords = this.lazy ? this.totalRecords : (this.value ? this.value.length : 0);
        //first
        if (this.totalRecords && this.first >= this.totalRecords) {
            var numberOfPages = Math.ceil(this.totalRecords / this.rows);
            this.first = Math.max((numberOfPages - 1) * this.rows, 0);
        }
    };
    DataGrid.prototype.paginate = function (event) {
        this.first = event.first;
        this.rows = event.rows;
        if (this.lazy) {
            this.onLazyLoad.emit(this.createLazyLoadMetadata());
        }
        else {
            this.updateDataToRender(this.value);
        }
        this.onPage.emit({
            first: this.first,
            rows: this.rows
        });
    };
    DataGrid.prototype.updateDataToRender = function (datasource) {
        if (this.paginator && datasource) {
            this.dataToRender = [];
            var startIndex = this.lazy ? 0 : this.first;
            for (var i = startIndex; i < (startIndex + this.rows); i++) {
                if (i >= datasource.length) {
                    break;
                }
                this.dataToRender.push(datasource[i]);
            }
        }
        else {
            this.dataToRender = datasource;
        }
    };
    DataGrid.prototype.isEmpty = function () {
        return !this.dataToRender || (this.dataToRender.length == 0);
    };
    DataGrid.prototype.createLazyLoadMetadata = function () {
        return {
            first: this.first,
            rows: this.rows
        };
    };
    DataGrid.prototype.getBlockableElement = function () {
        return this.el.nativeElement.children[0];
    };
    DataGrid.ɵfac = function DataGrid_Factory(t) { return new (t || DataGrid)(i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i0.IterableDiffers)); };
    DataGrid.ɵcmp = i0.ɵɵdefineComponent({ type: DataGrid, selectors: [["p-dataGrid"]], contentQueries: function DataGrid_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵcontentQuery(dirIndex, shared_1.Header, true);
            i0.ɵɵcontentQuery(dirIndex, shared_1.Footer, true);
            i0.ɵɵcontentQuery(dirIndex, shared_1.PrimeTemplate, false);
        } if (rf & 2) {
            var _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.header = _t.first);
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.footer = _t.first);
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.templates = _t);
        } }, inputs: { paginator: "paginator", rows: "rows", totalRecords: "totalRecords", pageLinks: "pageLinks", rowsPerPageOptions: "rowsPerPageOptions", lazy: "lazy", emptyMessage: "emptyMessage", style: "style", styleClass: "styleClass", paginatorPosition: "paginatorPosition", alwaysShowPaginator: "alwaysShowPaginator", trackBy: "trackBy", immutable: "immutable", value: "value" }, outputs: { onLazyLoad: "onLazyLoad", onPage: "onPage" }, ngContentSelectors: _c1, decls: 9, vars: 12, consts: [[3, "ngClass", "ngStyle"], ["class", "ui-datagrid-header ui-widget-header ui-corner-top", 4, "ngIf"], ["styleClass", "ui-paginator-bottom", 3, "rows", "first", "totalRecords", "pageLinkSize", "alwaysShow", "rowsPerPageOptions", "onPageChange", 4, "ngIf"], [1, "ui-datagrid-content", "ui-widget-content"], [1, "ui-g"], ["ngFor", "", 3, "ngForOf", "ngForTemplate", "ngForTrackBy"], ["class", "ui-widget-content ui-g-12", 4, "ngIf"], ["class", "ui-datagrid-footer ui-widget-header ui-corner-top", 4, "ngIf"], [1, "ui-datagrid-header", "ui-widget-header", "ui-corner-top"], ["styleClass", "ui-paginator-bottom", 3, "rows", "first", "totalRecords", "pageLinkSize", "alwaysShow", "rowsPerPageOptions", "onPageChange"], [1, "ui-widget-content", "ui-g-12"], [1, "ui-datagrid-footer", "ui-widget-header", "ui-corner-top"]], template: function DataGrid_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef(_c0);
            i0.ɵɵelementStart(0, "div", 0);
            i0.ɵɵtemplate(1, DataGrid_div_1_Template, 2, 0, "div", 1);
            i0.ɵɵtemplate(2, DataGrid_p_paginator_2_Template, 1, 6, "p-paginator", 2);
            i0.ɵɵelementStart(3, "div", 3);
            i0.ɵɵelementStart(4, "div", 4);
            i0.ɵɵtemplate(5, DataGrid_ng_template_5_Template, 0, 0, "ng-template", 5);
            i0.ɵɵtemplate(6, DataGrid_div_6_Template, 2, 1, "div", 6);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵtemplate(7, DataGrid_p_paginator_7_Template, 1, 6, "p-paginator", 2);
            i0.ɵɵtemplate(8, DataGrid_div_8_Template, 2, 0, "div", 7);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵclassMap(ctx.styleClass);
            i0.ɵɵproperty("ngClass", "ui-datagrid ui-widget")("ngStyle", ctx.style);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.header);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.paginator && ctx.paginatorPosition != "bottom" || ctx.paginatorPosition == "both");
            i0.ɵɵadvance(3);
            i0.ɵɵproperty("ngForOf", ctx.dataToRender)("ngForTemplate", ctx.itemTemplate)("ngForTrackBy", ctx.trackBy);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.isEmpty());
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.paginator && ctx.paginatorPosition != "top" || ctx.paginatorPosition == "both");
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.footer);
        } }, directives: [i1.NgClass, i1.NgStyle, i1.NgIf, i1.NgForOf, i2.Paginator], encapsulation: 2 });
    return DataGrid;
}());
exports.DataGrid = DataGrid;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(DataGrid, [{
        type: core_1.Component,
        args: [{
                selector: 'p-dataGrid',
                template: "\n        <div [ngClass]=\"'ui-datagrid ui-widget'\" [ngStyle]=\"style\" [class]=\"styleClass\">\n            <div class=\"ui-datagrid-header ui-widget-header ui-corner-top\" *ngIf=\"header\">\n                <ng-content select=\"p-header\"></ng-content>\n            </div>\n            <p-paginator [rows]=\"rows\" [first]=\"first\" [totalRecords]=\"totalRecords\" [pageLinkSize]=\"pageLinks\" [alwaysShow]=\"alwaysShowPaginator\"\n                (onPageChange)=\"paginate($event)\" styleClass=\"ui-paginator-bottom\" [rowsPerPageOptions]=\"rowsPerPageOptions\" *ngIf=\"paginator && paginatorPosition!='bottom' || paginatorPosition =='both'\"></p-paginator>\n            <div class=\"ui-datagrid-content ui-widget-content\">\n                <div class=\"ui-g\">\n                    <ng-template ngFor [ngForOf]=\"dataToRender\" [ngForTemplate]=\"itemTemplate\" [ngForTrackBy]=\"trackBy\"></ng-template>\n                    <div *ngIf=\"isEmpty()\" class=\"ui-widget-content ui-g-12\">{{emptyMessage}}</div>\n                </div>\n            </div>\n            <p-paginator [rows]=\"rows\" [first]=\"first\" [totalRecords]=\"totalRecords\" [pageLinkSize]=\"pageLinks\" [alwaysShow]=\"alwaysShowPaginator\"\n                (onPageChange)=\"paginate($event)\" styleClass=\"ui-paginator-bottom\" [rowsPerPageOptions]=\"rowsPerPageOptions\" *ngIf=\"paginator && paginatorPosition!='top' || paginatorPosition =='both'\"></p-paginator>\n            <div class=\"ui-datagrid-footer ui-widget-header ui-corner-top\" *ngIf=\"footer\">\n                <ng-content select=\"p-footer\"></ng-content>\n            </div>\n        </div>\n    "
            }]
    }], function () { return [{ type: i0.ElementRef }, { type: i0.IterableDiffers }]; }, { paginator: [{
            type: core_1.Input
        }], rows: [{
            type: core_1.Input
        }], totalRecords: [{
            type: core_1.Input
        }], pageLinks: [{
            type: core_1.Input
        }], rowsPerPageOptions: [{
            type: core_1.Input
        }], lazy: [{
            type: core_1.Input
        }], emptyMessage: [{
            type: core_1.Input
        }], onLazyLoad: [{
            type: core_1.Output
        }], style: [{
            type: core_1.Input
        }], styleClass: [{
            type: core_1.Input
        }], paginatorPosition: [{
            type: core_1.Input
        }], alwaysShowPaginator: [{
            type: core_1.Input
        }], trackBy: [{
            type: core_1.Input
        }], immutable: [{
            type: core_1.Input
        }], onPage: [{
            type: core_1.Output
        }], header: [{
            type: core_1.ContentChild,
            args: [shared_1.Header]
        }], footer: [{
            type: core_1.ContentChild,
            args: [shared_1.Footer]
        }], templates: [{
            type: core_1.ContentChildren,
            args: [shared_1.PrimeTemplate]
        }], value: [{
            type: core_1.Input
        }] }); })();
var DataGridModule = /** @class */ (function () {
    function DataGridModule() {
    }
    DataGridModule.ɵmod = i0.ɵɵdefineNgModule({ type: DataGridModule });
    DataGridModule.ɵinj = i0.ɵɵdefineInjector({ factory: function DataGridModule_Factory(t) { return new (t || DataGridModule)(); }, imports: [[common_1.CommonModule, shared_1.SharedModule, paginator_1.PaginatorModule],
            shared_1.SharedModule] });
    return DataGridModule;
}());
exports.DataGridModule = DataGridModule;
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(DataGridModule, { declarations: [DataGrid], imports: [common_1.CommonModule, shared_1.SharedModule, paginator_1.PaginatorModule], exports: [DataGrid,
        shared_1.SharedModule] }); })();
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(DataGridModule, [{
        type: core_1.NgModule,
        args: [{
                imports: [common_1.CommonModule, shared_1.SharedModule, paginator_1.PaginatorModule],
                exports: [DataGrid, shared_1.SharedModule],
                declarations: [DataGrid]
            }]
    }], null, null); })();
//# sourceMappingURL=datagrid.js.map