"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var domhandler_1 = require("../dom/domhandler");
var i0 = require("@angular/core");
var i1 = require("../dom/domhandler");
var DeferredLoader = /** @class */ (function () {
    function DeferredLoader(el, domHandler, renderer, viewContainer) {
        this.el = el;
        this.domHandler = domHandler;
        this.renderer = renderer;
        this.viewContainer = viewContainer;
        this.onLoad = new core_1.EventEmitter();
    }
    DeferredLoader.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (this.shouldLoad()) {
            this.load();
        }
        this.documentScrollListener = this.renderer.listen('window', 'scroll', function () {
            if (_this.shouldLoad()) {
                _this.load();
                _this.documentScrollListener();
                _this.documentScrollListener = null;
            }
        });
    };
    DeferredLoader.prototype.shouldLoad = function () {
        var rect = this.el.nativeElement.getBoundingClientRect();
        var docElement = document.documentElement;
        var scrollTop = (window.pageYOffset || document.documentElement.scrollTop);
        var winHeight = docElement.clientHeight;
        return (winHeight >= rect.top);
    };
    DeferredLoader.prototype.load = function () {
        this.view = this.viewContainer.createEmbeddedView(this.template);
        this.onLoad.emit();
    };
    DeferredLoader.prototype.ngOnDestroy = function () {
        this.view = null;
        if (this.documentScrollListener) {
            this.documentScrollListener();
        }
    };
    DeferredLoader.ɵfac = function DeferredLoader_Factory(t) { return new (t || DeferredLoader)(i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i1.DomHandler), i0.ɵɵdirectiveInject(i0.Renderer2), i0.ɵɵdirectiveInject(i0.ViewContainerRef)); };
    DeferredLoader.ɵdir = i0.ɵɵdefineDirective({ type: DeferredLoader, selectors: [["", "pDefer", ""]], contentQueries: function DeferredLoader_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵcontentQuery(dirIndex, core_1.TemplateRef, true);
        } if (rf & 2) {
            var _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.template = _t.first);
        } }, outputs: { onLoad: "onLoad" }, features: [i0.ɵɵProvidersFeature([domhandler_1.DomHandler])] });
    return DeferredLoader;
}());
exports.DeferredLoader = DeferredLoader;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(DeferredLoader, [{
        type: core_1.Directive,
        args: [{
                selector: '[pDefer]',
                host: {},
                providers: [domhandler_1.DomHandler]
            }]
    }], function () { return [{ type: i0.ElementRef }, { type: i1.DomHandler }, { type: i0.Renderer2 }, { type: i0.ViewContainerRef }]; }, { onLoad: [{
            type: core_1.Output
        }], template: [{
            type: core_1.ContentChild,
            args: [core_1.TemplateRef]
        }] }); })();
var DeferModule = /** @class */ (function () {
    function DeferModule() {
    }
    DeferModule.ɵmod = i0.ɵɵdefineNgModule({ type: DeferModule });
    DeferModule.ɵinj = i0.ɵɵdefineInjector({ factory: function DeferModule_Factory(t) { return new (t || DeferModule)(); }, imports: [[common_1.CommonModule]] });
    return DeferModule;
}());
exports.DeferModule = DeferModule;
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(DeferModule, { declarations: [DeferredLoader], imports: [common_1.CommonModule], exports: [DeferredLoader] }); })();
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(DeferModule, [{
        type: core_1.NgModule,
        args: [{
                imports: [common_1.CommonModule],
                exports: [DeferredLoader],
                declarations: [DeferredLoader]
            }]
    }], null, null); })();
//# sourceMappingURL=defer.js.map