import { ElementRef, EventEmitter } from '@angular/core';
import { DomHandler } from '../dom/domhandler';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
export declare class Draggable {
    el: ElementRef;
    domHandler: DomHandler;
    scope: string;
    dragEffect: string;
    dragHandle: string;
    onDragStart: EventEmitter<any>;
    onDragEnd: EventEmitter<any>;
    onDrag: EventEmitter<any>;
    handle: any;
    constructor(el: ElementRef, domHandler: DomHandler);
    dragStart(event: any): void;
    drag(event: any): void;
    dragEnd(event: any): void;
    mouseover(event: any): void;
    mouseleave(event: any): void;
    allowDrag(): boolean;
    static ɵfac: i0.ɵɵFactoryDef<Draggable, never>;
    static ɵdir: i0.ɵɵDirectiveDefWithMeta<Draggable, "[pDraggable]", never, { "scope": "pDraggable"; "dragEffect": "dragEffect"; "dragHandle": "dragHandle"; }, { "onDragStart": "onDragStart"; "onDragEnd": "onDragEnd"; "onDrag": "onDrag"; }, never>;
}
export declare class Droppable {
    el: ElementRef;
    domHandler: DomHandler;
    scope: string | string[];
    dropEffect: string;
    onDragEnter: EventEmitter<any>;
    onDragLeave: EventEmitter<any>;
    onDrop: EventEmitter<any>;
    onDragOver: EventEmitter<any>;
    constructor(el: ElementRef, domHandler: DomHandler);
    drop(event: any): void;
    dragEnter(event: any): void;
    dragLeave(event: any): void;
    dragOver(event: any): void;
    allowDrop(event: any): boolean;
    static ɵfac: i0.ɵɵFactoryDef<Droppable, never>;
    static ɵdir: i0.ɵɵDirectiveDefWithMeta<Droppable, "[pDroppable]", never, { "scope": "pDroppable"; "dropEffect": "dropEffect"; }, { "onDragEnter": "onDragEnter"; "onDragLeave": "onDragLeave"; "onDrop": "onDrop"; "onDragOver": "onDragOver"; }, never>;
}
export declare class DragDropModule {
    static ɵmod: i0.ɵɵNgModuleDefWithMeta<DragDropModule, [typeof Draggable, typeof Droppable], [typeof i1.CommonModule], [typeof Draggable, typeof Droppable]>;
    static ɵinj: i0.ɵɵInjectorDef<DragDropModule>;
}
