"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var domhandler_1 = require("../dom/domhandler");
var i0 = require("@angular/core");
var i1 = require("../dom/domhandler");
var Draggable = /** @class */ (function () {
    function Draggable(el, domHandler) {
        this.el = el;
        this.domHandler = domHandler;
        this.onDragStart = new core_1.EventEmitter();
        this.onDragEnd = new core_1.EventEmitter();
        this.onDrag = new core_1.EventEmitter();
    }
    Draggable.prototype.dragStart = function (event) {
        if (this.allowDrag()) {
            if (this.dragEffect) {
                event.dataTransfer.effectAllowed = this.dragEffect;
            }
            event.dataTransfer.setData('text', this.scope);
            this.onDragStart.emit(event);
        }
        else {
            event.preventDefault();
        }
    };
    Draggable.prototype.drag = function (event) {
        this.onDrag.emit(event);
    };
    Draggable.prototype.dragEnd = function (event) {
        this.onDragEnd.emit(event);
    };
    Draggable.prototype.mouseover = function (event) {
        this.handle = event.target;
    };
    Draggable.prototype.mouseleave = function (event) {
        this.handle = null;
    };
    Draggable.prototype.allowDrag = function () {
        if (this.dragHandle && this.handle)
            return this.domHandler.matches(this.handle, this.dragHandle);
        else
            return true;
    };
    Draggable.ɵfac = function Draggable_Factory(t) { return new (t || Draggable)(i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i1.DomHandler)); };
    Draggable.ɵdir = i0.ɵɵdefineDirective({ type: Draggable, selectors: [["", "pDraggable", ""]], hostVars: 1, hostBindings: function Draggable_HostBindings(rf, ctx) { if (rf & 1) {
            i0.ɵɵlistener("dragstart", function Draggable_dragstart_HostBindingHandler($event) { return ctx.dragStart($event); })("drag", function Draggable_drag_HostBindingHandler($event) { return ctx.drag($event); })("dragend", function Draggable_dragend_HostBindingHandler($event) { return ctx.dragEnd($event); })("mouseover", function Draggable_mouseover_HostBindingHandler($event) { return ctx.mouseover($event); })("mouseleave", function Draggable_mouseleave_HostBindingHandler($event) { return ctx.mouseleave($event); });
        } if (rf & 2) {
            i0.ɵɵhostProperty("draggable", true);
        } }, inputs: { scope: ["pDraggable", "scope"], dragEffect: "dragEffect", dragHandle: "dragHandle" }, outputs: { onDragStart: "onDragStart", onDragEnd: "onDragEnd", onDrag: "onDrag" }, features: [i0.ɵɵProvidersFeature([domhandler_1.DomHandler])] });
    return Draggable;
}());
exports.Draggable = Draggable;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(Draggable, [{
        type: core_1.Directive,
        args: [{
                selector: '[pDraggable]',
                host: {
                    '[draggable]': 'true'
                },
                providers: [domhandler_1.DomHandler]
            }]
    }], function () { return [{ type: i0.ElementRef }, { type: i1.DomHandler }]; }, { scope: [{
            type: core_1.Input,
            args: ['pDraggable']
        }], dragEffect: [{
            type: core_1.Input
        }], dragHandle: [{
            type: core_1.Input
        }], onDragStart: [{
            type: core_1.Output
        }], onDragEnd: [{
            type: core_1.Output
        }], onDrag: [{
            type: core_1.Output
        }], dragStart: [{
            type: core_1.HostListener,
            args: ['dragstart', ['$event']]
        }], drag: [{
            type: core_1.HostListener,
            args: ['drag', ['$event']]
        }], dragEnd: [{
            type: core_1.HostListener,
            args: ['dragend', ['$event']]
        }], mouseover: [{
            type: core_1.HostListener,
            args: ['mouseover', ['$event']]
        }], mouseleave: [{
            type: core_1.HostListener,
            args: ['mouseleave', ['$event']]
        }] }); })();
var Droppable = /** @class */ (function () {
    function Droppable(el, domHandler) {
        this.el = el;
        this.domHandler = domHandler;
        this.onDragEnter = new core_1.EventEmitter();
        this.onDragLeave = new core_1.EventEmitter();
        this.onDrop = new core_1.EventEmitter();
        this.onDragOver = new core_1.EventEmitter();
    }
    Droppable.prototype.drop = function (event) {
        if (this.allowDrop(event)) {
            event.preventDefault();
            this.onDrop.emit(event);
        }
    };
    Droppable.prototype.dragEnter = function (event) {
        event.preventDefault();
        if (this.dropEffect) {
            event.dataTransfer.dropEffect = this.dropEffect;
        }
        this.onDragEnter.emit(event);
    };
    Droppable.prototype.dragLeave = function (event) {
        event.preventDefault();
        this.onDragLeave.emit(event);
    };
    Droppable.prototype.dragOver = function (event) {
        event.preventDefault();
        this.onDragOver.emit(event);
    };
    Droppable.prototype.allowDrop = function (event) {
        var dragScope = event.dataTransfer.getData('text');
        if (typeof (this.scope) == "string" && dragScope == this.scope) {
            return true;
        }
        else if (this.scope instanceof Array) {
            for (var j = 0; j < this.scope.length; j++) {
                if (dragScope == this.scope[j]) {
                    return true;
                }
            }
        }
        return false;
    };
    Droppable.ɵfac = function Droppable_Factory(t) { return new (t || Droppable)(i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i1.DomHandler)); };
    Droppable.ɵdir = i0.ɵɵdefineDirective({ type: Droppable, selectors: [["", "pDroppable", ""]], hostBindings: function Droppable_HostBindings(rf, ctx) { if (rf & 1) {
            i0.ɵɵlistener("drop", function Droppable_drop_HostBindingHandler($event) { return ctx.drop($event); })("dragenter", function Droppable_dragenter_HostBindingHandler($event) { return ctx.dragEnter($event); })("dragleave", function Droppable_dragleave_HostBindingHandler($event) { return ctx.dragLeave($event); })("dragover", function Droppable_dragover_HostBindingHandler($event) { return ctx.dragOver($event); });
        } }, inputs: { scope: ["pDroppable", "scope"], dropEffect: "dropEffect" }, outputs: { onDragEnter: "onDragEnter", onDragLeave: "onDragLeave", onDrop: "onDrop", onDragOver: "onDragOver" }, features: [i0.ɵɵProvidersFeature([domhandler_1.DomHandler])] });
    return Droppable;
}());
exports.Droppable = Droppable;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(Droppable, [{
        type: core_1.Directive,
        args: [{
                selector: '[pDroppable]',
                providers: [domhandler_1.DomHandler]
            }]
    }], function () { return [{ type: i0.ElementRef }, { type: i1.DomHandler }]; }, { scope: [{
            type: core_1.Input,
            args: ['pDroppable']
        }], dropEffect: [{
            type: core_1.Input
        }], onDragEnter: [{
            type: core_1.Output
        }], onDragLeave: [{
            type: core_1.Output
        }], onDrop: [{
            type: core_1.Output
        }], onDragOver: [{
            type: core_1.Output
        }], drop: [{
            type: core_1.HostListener,
            args: ['drop', ['$event']]
        }], dragEnter: [{
            type: core_1.HostListener,
            args: ['dragenter', ['$event']]
        }], dragLeave: [{
            type: core_1.HostListener,
            args: ['dragleave', ['$event']]
        }], dragOver: [{
            type: core_1.HostListener,
            args: ['dragover', ['$event']]
        }] }); })();
var DragDropModule = /** @class */ (function () {
    function DragDropModule() {
    }
    DragDropModule.ɵmod = i0.ɵɵdefineNgModule({ type: DragDropModule });
    DragDropModule.ɵinj = i0.ɵɵdefineInjector({ factory: function DragDropModule_Factory(t) { return new (t || DragDropModule)(); }, imports: [[common_1.CommonModule]] });
    return DragDropModule;
}());
exports.DragDropModule = DragDropModule;
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(DragDropModule, { declarations: [Draggable,
        Droppable], imports: [common_1.CommonModule], exports: [Draggable,
        Droppable] }); })();
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(DragDropModule, [{
        type: core_1.NgModule,
        args: [{
                imports: [common_1.CommonModule],
                exports: [Draggable, Droppable],
                declarations: [Draggable, Droppable]
            }]
    }], null, null); })();
//# sourceMappingURL=dragdrop.js.map