"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var animations_1 = require("@angular/animations");
var common_1 = require("@angular/common");
var shared_1 = require("../common/shared");
var i0 = require("@angular/core");
var i1 = require("@angular/common");
var _c0 = function (a0, a1) { return { "fa-minus": a0, "fa-plus": a1 }; };
function Fieldset_span_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "span", 5);
} if (rf & 2) {
    var ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵproperty("ngClass", i0.ɵɵpureFunction2(1, _c0, !ctx_r0.collapsed, ctx_r0.collapsed));
} }
var _c1 = [[["p-header"]], "*"];
var _c2 = function (a1) { return { "ui-fieldset ui-widget ui-widget-content ui-corner-all": true, "ui-fieldset-toggleable": a1 }; };
var _c3 = function (a0) { return { "ui-fieldset-content-wrapper-overflown": a0 }; };
var _c4 = ["p-header", "*"];
var Fieldset = /** @class */ (function () {
    function Fieldset(el) {
        this.el = el;
        this.collapsed = false;
        this.onBeforeToggle = new core_1.EventEmitter();
        this.onAfterToggle = new core_1.EventEmitter();
    }
    Fieldset.prototype.toggle = function (event) {
        if (this.toggleable) {
            if (this.animating) {
                return false;
            }
            this.animating = true;
            this.onBeforeToggle.emit({ originalEvent: event, collapsed: this.collapsed });
            if (this.collapsed)
                this.expand(event);
            else
                this.collapse(event);
            this.onAfterToggle.emit({ originalEvent: event, collapsed: this.collapsed });
        }
    };
    Fieldset.prototype.expand = function (event) {
        this.collapsed = false;
    };
    Fieldset.prototype.collapse = function (event) {
        this.collapsed = true;
    };
    Fieldset.prototype.getBlockableElement = function () {
        return this.el.nativeElement.children[0];
    };
    Fieldset.prototype.onToggleDone = function (event) {
        this.animating = false;
    };
    Fieldset.ɵfac = function Fieldset_Factory(t) { return new (t || Fieldset)(i0.ɵɵdirectiveInject(i0.ElementRef)); };
    Fieldset.ɵcmp = i0.ɵɵdefineComponent({ type: Fieldset, selectors: [["p-fieldset"]], inputs: { legend: "legend", toggleable: "toggleable", collapsed: "collapsed", style: "style", styleClass: "styleClass" }, outputs: { onBeforeToggle: "onBeforeToggle", onAfterToggle: "onAfterToggle" }, ngContentSelectors: _c4, decls: 8, vars: 12, consts: [[3, "ngClass", "ngStyle"], [1, "ui-fieldset-legend", "ui-corner-all", "ui-state-default", "ui-unselectable-text", 3, "click"], ["class", "ui-fieldset-toggler fa fa-w", 3, "ngClass", 4, "ngIf"], [1, "ui-fieldset-content-wrapper", 3, "ngClass"], [1, "ui-fieldset-content"], [1, "ui-fieldset-toggler", "fa", "fa-w", 3, "ngClass"]], template: function Fieldset_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef(_c1);
            i0.ɵɵelementStart(0, "fieldset", 0);
            i0.ɵɵelementStart(1, "legend", 1);
            i0.ɵɵlistener("click", function Fieldset_Template_legend_click_1_listener($event) { return ctx.toggle($event); });
            i0.ɵɵtemplate(2, Fieldset_span_2_Template, 1, 4, "span", 2);
            i0.ɵɵtext(3);
            i0.ɵɵprojection(4);
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(5, "div", 3);
            i0.ɵɵlistener("@fieldsetContent.done", function Fieldset_Template_div_animation_fieldsetContent_done_5_listener($event) { return ctx.onToggleDone($event); });
            i0.ɵɵelementStart(6, "div", 4);
            i0.ɵɵprojection(7, 1);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵclassMap(ctx.styleClass);
            i0.ɵɵproperty("ngClass", i0.ɵɵpureFunction1(8, _c2, ctx.toggleable))("ngStyle", ctx.style);
            i0.ɵɵadvance(2);
            i0.ɵɵproperty("ngIf", ctx.toggleable);
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate1(" ", ctx.legend, " ");
            i0.ɵɵadvance(2);
            i0.ɵɵproperty("@fieldsetContent", ctx.collapsed ? "hidden" : "visible")("ngClass", i0.ɵɵpureFunction1(10, _c3, ctx.collapsed || ctx.animating));
        } }, directives: [i1.NgClass, i1.NgStyle, i1.NgIf], encapsulation: 2, data: { animation: [
                animations_1.trigger('fieldsetContent', [
                    animations_1.state('hidden', animations_1.style({
                        height: '0px'
                    })),
                    animations_1.state('visible', animations_1.style({
                        height: '*'
                    })),
                    animations_1.transition('visible => hidden', animations_1.animate('400ms cubic-bezier(0.86, 0, 0.07, 1)')),
                    animations_1.transition('hidden => visible', animations_1.animate('400ms cubic-bezier(0.86, 0, 0.07, 1)'))
                ])
            ] } });
    return Fieldset;
}());
exports.Fieldset = Fieldset;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(Fieldset, [{
        type: core_1.Component,
        args: [{
                selector: 'p-fieldset',
                template: "\n        <fieldset [ngClass]=\"{'ui-fieldset ui-widget ui-widget-content ui-corner-all': true, 'ui-fieldset-toggleable': toggleable}\" [ngStyle]=\"style\" [class]=\"styleClass\">\n            <legend class=\"ui-fieldset-legend ui-corner-all ui-state-default ui-unselectable-text\" (click)=\"toggle($event)\">\n                <span *ngIf=\"toggleable\" class=\"ui-fieldset-toggler fa fa-w\" [ngClass]=\"{'fa-minus': !collapsed,'fa-plus':collapsed}\"></span>\n                {{legend}}\n                <ng-content select=\"p-header\"></ng-content>\n            </legend>\n            <div class=\"ui-fieldset-content-wrapper\" [@fieldsetContent]=\"collapsed ? 'hidden' : 'visible'\" \n                        [ngClass]=\"{'ui-fieldset-content-wrapper-overflown': collapsed||animating}\"\n                         (@fieldsetContent.done)=\"onToggleDone($event)\">\n                <div class=\"ui-fieldset-content\">\n                    <ng-content></ng-content>\n                </div>\n            </div>\n        </fieldset>\n    ",
                animations: [
                    animations_1.trigger('fieldsetContent', [
                        animations_1.state('hidden', animations_1.style({
                            height: '0px'
                        })),
                        animations_1.state('visible', animations_1.style({
                            height: '*'
                        })),
                        animations_1.transition('visible => hidden', animations_1.animate('400ms cubic-bezier(0.86, 0, 0.07, 1)')),
                        animations_1.transition('hidden => visible', animations_1.animate('400ms cubic-bezier(0.86, 0, 0.07, 1)'))
                    ])
                ]
            }]
    }], function () { return [{ type: i0.ElementRef }]; }, { legend: [{
            type: core_1.Input
        }], toggleable: [{
            type: core_1.Input
        }], collapsed: [{
            type: core_1.Input
        }], onBeforeToggle: [{
            type: core_1.Output
        }], onAfterToggle: [{
            type: core_1.Output
        }], style: [{
            type: core_1.Input
        }], styleClass: [{
            type: core_1.Input
        }] }); })();
var FieldsetModule = /** @class */ (function () {
    function FieldsetModule() {
    }
    FieldsetModule.ɵmod = i0.ɵɵdefineNgModule({ type: FieldsetModule });
    FieldsetModule.ɵinj = i0.ɵɵdefineInjector({ factory: function FieldsetModule_Factory(t) { return new (t || FieldsetModule)(); }, imports: [[common_1.CommonModule],
            shared_1.SharedModule] });
    return FieldsetModule;
}());
exports.FieldsetModule = FieldsetModule;
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(FieldsetModule, { declarations: [Fieldset], imports: [common_1.CommonModule], exports: [Fieldset,
        shared_1.SharedModule] }); })();
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(FieldsetModule, [{
        type: core_1.NgModule,
        args: [{
                imports: [common_1.CommonModule],
                exports: [Fieldset, shared_1.SharedModule],
                declarations: [Fieldset]
            }]
    }], null, null); })();
//# sourceMappingURL=fieldset.js.map