import { ElementRef, AfterViewInit, DoCheck, OnDestroy, EventEmitter, IterableDiffers } from '@angular/core';
import { Message } from '../common/message';
import { DomHandler } from '../dom/domhandler';
import { MessageService } from '../common/messageservice';
import { Subscription } from 'rxjs';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
export declare class Growl implements AfterViewInit, DoCheck, OnDestroy {
    el: ElementRef;
    domHandler: DomHandler;
    differs: IterableDiffers;
    messageService: MessageService;
    sticky: boolean;
    life: number;
    style: any;
    styleClass: string;
    immutable: boolean;
    autoZIndex: boolean;
    baseZIndex: number;
    onClick: EventEmitter<any>;
    onHover: EventEmitter<any>;
    onClose: EventEmitter<any>;
    valueChange: EventEmitter<Message[]>;
    containerViewChild: ElementRef;
    _value: Message[];
    timeout: any;
    preventRerender: boolean;
    differ: any;
    subscription: Subscription;
    closeIconClick: boolean;
    constructor(el: ElementRef, domHandler: DomHandler, differs: IterableDiffers, messageService: MessageService);
    ngAfterViewInit(): void;
    get value(): Message[];
    set value(val: Message[]);
    ngDoCheck(): void;
    handleValueChange(): void;
    initTimeout(): void;
    remove(index: number, msgel: any): void;
    removeAll(): void;
    onMessageClick(i: number): void;
    onMessageHover(i: number): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDef<Growl, [null, null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<Growl, "p-growl", never, { "sticky": "sticky"; "life": "life"; "style": "style"; "styleClass": "styleClass"; "immutable": "immutable"; "autoZIndex": "autoZIndex"; "baseZIndex": "baseZIndex"; "value": "value"; }, { "onClick": "onClick"; "onHover": "onHover"; "onClose": "onClose"; "valueChange": "valueChange"; }, never, never>;
}
export declare class GrowlModule {
    static ɵmod: i0.ɵɵNgModuleDefWithMeta<GrowlModule, [typeof Growl], [typeof i1.CommonModule], [typeof Growl]>;
    static ɵinj: i0.ɵɵInjectorDef<GrowlModule>;
}
