"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var i0 = require("@angular/core");
var InputTextarea = /** @class */ (function () {
    function InputTextarea(el) {
        this.el = el;
        this.onResize = new core_1.EventEmitter();
    }
    InputTextarea.prototype.ngOnInit = function () {
        this.rowsDefault = this.rows;
        this.colsDefault = this.cols;
    };
    InputTextarea.prototype.ngDoCheck = function () {
        this.updateFilledState();
    };
    //To trigger change detection to manage ui-state-filled for material labels when there is no value binding
    InputTextarea.prototype.onInput = function (e) {
        this.updateFilledState();
    };
    InputTextarea.prototype.updateFilledState = function () {
        this.filled = this.el.nativeElement.value && this.el.nativeElement.value.length;
    };
    InputTextarea.prototype.onFocus = function (e) {
        if (this.autoResize) {
            this.resize(e);
        }
    };
    InputTextarea.prototype.onBlur = function (e) {
        if (this.autoResize) {
            this.resize(e);
        }
    };
    InputTextarea.prototype.onKeyup = function (e) {
        if (this.autoResize) {
            this.resize(e);
        }
    };
    InputTextarea.prototype.resize = function (event) {
        var linesCount = 0, lines = this.el.nativeElement.value.split('\n');
        for (var i = lines.length - 1; i >= 0; --i) {
            linesCount += Math.floor((lines[i].length / this.colsDefault) + 1);
        }
        this.rows = (linesCount >= this.rowsDefault) ? (linesCount + 1) : this.rowsDefault;
        this.onResize.emit(event || {});
    };
    InputTextarea.ɵfac = function InputTextarea_Factory(t) { return new (t || InputTextarea)(i0.ɵɵdirectiveInject(i0.ElementRef)); };
    InputTextarea.ɵdir = i0.ɵɵdefineDirective({ type: InputTextarea, selectors: [["", "pInputTextarea", ""]], hostVars: 12, hostBindings: function InputTextarea_HostBindings(rf, ctx) { if (rf & 1) {
            i0.ɵɵlistener("input", function InputTextarea_input_HostBindingHandler($event) { return ctx.onInput($event); })("focus", function InputTextarea_focus_HostBindingHandler($event) { return ctx.onFocus($event); })("blur", function InputTextarea_blur_HostBindingHandler($event) { return ctx.onBlur($event); })("keyup", function InputTextarea_keyup_HostBindingHandler($event) { return ctx.onKeyup($event); });
        } if (rf & 2) {
            i0.ɵɵattribute("rows", ctx.rows)("cols", ctx.cols);
            i0.ɵɵclassProp("ui-inputtext", true)("ui-corner-all", true)("ui-state-default", true)("ui-widget", true)("ui-state-filled", ctx.filled);
        } }, inputs: { autoResize: "autoResize", rows: "rows", cols: "cols" }, outputs: { onResize: "onResize" } });
    return InputTextarea;
}());
exports.InputTextarea = InputTextarea;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(InputTextarea, [{
        type: core_1.Directive,
        args: [{
                selector: '[pInputTextarea]',
                host: {
                    '[class.ui-inputtext]': 'true',
                    '[class.ui-corner-all]': 'true',
                    '[class.ui-state-default]': 'true',
                    '[class.ui-widget]': 'true',
                    '[class.ui-state-filled]': 'filled',
                    '[attr.rows]': 'rows',
                    '[attr.cols]': 'cols'
                }
            }]
    }], function () { return [{ type: i0.ElementRef }]; }, { autoResize: [{
            type: core_1.Input
        }], rows: [{
            type: core_1.Input
        }], cols: [{
            type: core_1.Input
        }], onResize: [{
            type: core_1.Output
        }], onInput: [{
            type: core_1.HostListener,
            args: ['input', ['$event']]
        }], onFocus: [{
            type: core_1.HostListener,
            args: ['focus', ['$event']]
        }], onBlur: [{
            type: core_1.HostListener,
            args: ['blur', ['$event']]
        }], onKeyup: [{
            type: core_1.HostListener,
            args: ['keyup', ['$event']]
        }] }); })();
var InputTextareaModule = /** @class */ (function () {
    function InputTextareaModule() {
    }
    InputTextareaModule.ɵmod = i0.ɵɵdefineNgModule({ type: InputTextareaModule });
    InputTextareaModule.ɵinj = i0.ɵɵdefineInjector({ factory: function InputTextareaModule_Factory(t) { return new (t || InputTextareaModule)(); }, imports: [[common_1.CommonModule]] });
    return InputTextareaModule;
}());
exports.InputTextareaModule = InputTextareaModule;
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(InputTextareaModule, { declarations: [InputTextarea], imports: [common_1.CommonModule], exports: [InputTextarea] }); })();
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(InputTextareaModule, [{
        type: core_1.NgModule,
        args: [{
                imports: [common_1.CommonModule],
                exports: [InputTextarea],
                declarations: [InputTextarea]
            }]
    }], null, null); })();
//# sourceMappingURL=inputtextarea.js.map