import { ElementRef, EventEmitter, AfterContentInit, QueryList, TemplateRef, ChangeDetectorRef } from '@angular/core';
import { SelectItem } from '../common/selectitem';
import { DomHandler } from '../dom/domhandler';
import { ObjectUtils } from '../utils/objectutils';
import { ControlValueAccessor } from '@angular/forms';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
import * as i2 from "../common/shared";
export declare const LISTBOX_VALUE_ACCESSOR: any;
export declare class Listbox implements AfterContentInit, ControlValueAccessor {
    el: ElementRef;
    domHandler: DomHandler;
    objectUtils: ObjectUtils;
    cd: ChangeDetectorRef;
    multiple: boolean;
    style: any;
    styleClass: string;
    listStyle: any;
    readonly: boolean;
    disabled: boolean;
    checkbox: boolean;
    filter: boolean;
    filterMode: string;
    metaKeySelection: boolean;
    dataKey: string;
    showToggleAll: boolean;
    optionLabel: string;
    onChange: EventEmitter<any>;
    onDblClick: EventEmitter<any>;
    headerFacet: any;
    footerFacet: any;
    templates: QueryList<any>;
    itemTemplate: TemplateRef<any>;
    filterValue: string;
    filtered: boolean;
    value: any;
    onModelChange: Function;
    onModelTouched: Function;
    checkboxClick: boolean;
    optionTouched: boolean;
    focus: boolean;
    _options: any[];
    constructor(el: ElementRef, domHandler: DomHandler, objectUtils: ObjectUtils, cd: ChangeDetectorRef);
    get options(): any[];
    set options(val: any[]);
    ngAfterContentInit(): void;
    writeValue(value: any): void;
    registerOnChange(fn: Function): void;
    registerOnTouched(fn: Function): void;
    setDisabledState(val: boolean): void;
    onOptionClick(event: any, option: any): void;
    onOptionTouchEnd(event: any, option: any): void;
    onOptionClickSingle(event: any, option: any): void;
    onOptionClickMultiple(event: any, option: any): void;
    removeOption(option: any): void;
    isSelected(option: SelectItem): boolean;
    get allChecked(): boolean;
    allFilteredSelected(): boolean;
    onFilter(event: any): void;
    toggleAll(event: any, checkbox: any): void;
    isItemVisible(option: SelectItem): boolean;
    onDoubleClick(event: Event, option: SelectItem): any;
    onCheckboxClick(event: Event, option: SelectItem): void;
    onInputFocus(event: any): void;
    onInputBlur(event: any): void;
    static ɵfac: i0.ɵɵFactoryDef<Listbox, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<Listbox, "p-listbox", never, { "multiple": "multiple"; "style": "style"; "styleClass": "styleClass"; "listStyle": "listStyle"; "readonly": "readonly"; "disabled": "disabled"; "checkbox": "checkbox"; "filter": "filter"; "filterMode": "filterMode"; "metaKeySelection": "metaKeySelection"; "dataKey": "dataKey"; "showToggleAll": "showToggleAll"; "optionLabel": "optionLabel"; "options": "options"; }, { "onChange": "onChange"; "onDblClick": "onDblClick"; }, ["headerFacet", "footerFacet", "templates"], ["p-header", "p-footer"]>;
}
export declare class ListboxModule {
    static ɵmod: i0.ɵɵNgModuleDefWithMeta<ListboxModule, [typeof Listbox], [typeof i1.CommonModule, typeof i2.SharedModule], [typeof Listbox, typeof i2.SharedModule]>;
    static ɵinj: i0.ɵɵInjectorDef<ListboxModule>;
}
