import { ElementRef, OnInit, AfterViewInit, AfterContentInit, AfterViewChecked, OnDestroy, Renderer2, EventEmitter, ChangeDetectorRef, TemplateRef, QueryList } from '@angular/core';
import { SelectItem } from '../common/selectitem';
import { DomHandler } from '../dom/domhandler';
import { ObjectUtils } from '../utils/objectutils';
import { ControlValueAccessor } from '@angular/forms';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
import * as i2 from "../common/shared";
export declare const MULTISELECT_VALUE_ACCESSOR: any;
export declare class MultiSelect implements OnInit, AfterViewInit, AfterContentInit, AfterViewChecked, OnDestroy, ControlValueAccessor {
    el: ElementRef;
    domHandler: DomHandler;
    renderer: Renderer2;
    objectUtils: ObjectUtils;
    private cd;
    scrollHeight: string;
    defaultLabel: string;
    style: any;
    styleClass: string;
    panelStyle: any;
    panelStyleClass: string;
    inputId: string;
    disabled: boolean;
    readonly: boolean;
    filter: boolean;
    overlayVisible: boolean;
    tabindex: number;
    appendTo: any;
    dataKey: string;
    displaySelectedLabel: boolean;
    maxSelectedLabels: number;
    selectedItemsLabel: string;
    showToggleAll: boolean;
    resetFilterOnHide: boolean;
    dropdownIcon: string;
    optionLabel: string;
    containerViewChild: ElementRef;
    itemsWrapperViewChild: ElementRef;
    panelViewChild: ElementRef;
    filterInputChild: ElementRef;
    templates: QueryList<any>;
    onChange: EventEmitter<any>;
    onFocus_1: EventEmitter<any>;
    onBlur_1: EventEmitter<any>;
    onFocus: EventEmitter<any>;
    onBlur: EventEmitter<any>;
    onPanelShow: EventEmitter<any>;
    onPanelHide: EventEmitter<any>;
    value: any[];
    onModelChange: Function;
    onModelTouched: Function;
    valuesAsString: string;
    focus: boolean;
    focusCounter: number;
    selectedOptionUpdated: boolean;
    documentClickListener: any;
    container: HTMLDivElement;
    itemsWrapper: HTMLDivElement;
    panel: HTMLDivElement;
    selfClick: boolean;
    panelClick: boolean;
    filterValue: string;
    visibleOptions: SelectItem[];
    filtered: boolean;
    itemTemplate: TemplateRef<any>;
    _options: any[];
    constructor(el: ElementRef, domHandler: DomHandler, renderer: Renderer2, objectUtils: ObjectUtils, cd: ChangeDetectorRef);
    get options(): any[];
    set options(val: any[]);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
    ngAfterViewChecked(): void;
    writeValue(value: any): void;
    registerOnChange(fn: Function): void;
    registerOnTouched(fn: Function): void;
    setDisabledState(val: boolean): void;
    onItemClick(event: any, value: any): void;
    isSelected(value: any): boolean;
    findSelectionIndex(val: any): number;
    toggleAll(event: any, checkbox: any): void;
    isAllChecked(): boolean;
    show(): void;
    hide(): void;
    close(event: any, filter: any): void;
    onMouseclick(event: any, input: any): void;
    onInputFocus(event: any): void;
    onInputBlur(event: any): void;
    onKeydown(event: any): void;
    updateLabel(): void;
    findLabelByValue(val: any): string;
    onFilter(event: any): void;
    isItemVisible(option: SelectItem): boolean;
    getVisibleOptions(): SelectItem[];
    bindDocumentClickListener(): void;
    unbindDocumentClickListener(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDef<MultiSelect, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<MultiSelect, "p-multiSelect", never, { "scrollHeight": "scrollHeight"; "defaultLabel": "defaultLabel"; "style": "style"; "styleClass": "styleClass"; "panelStyle": "panelStyle"; "panelStyleClass": "panelStyleClass"; "inputId": "inputId"; "disabled": "disabled"; "readonly": "readonly"; "filter": "filter"; "overlayVisible": "overlayVisible"; "tabindex": "tabindex"; "appendTo": "appendTo"; "dataKey": "dataKey"; "displaySelectedLabel": "displaySelectedLabel"; "maxSelectedLabels": "maxSelectedLabels"; "selectedItemsLabel": "selectedItemsLabel"; "showToggleAll": "showToggleAll"; "resetFilterOnHide": "resetFilterOnHide"; "dropdownIcon": "dropdownIcon"; "optionLabel": "optionLabel"; "options": "options"; }, { "onChange": "onChange"; "onFocus_1": "onFocus_1"; "onBlur_1": "onBlur_1"; "onFocus": "onFocus"; "onBlur": "onBlur"; "onPanelShow": "onPanelShow"; "onPanelHide": "onPanelHide"; }, ["templates"], never>;
}
export declare class MultiSelectModule {
    static ɵmod: i0.ɵɵNgModuleDefWithMeta<MultiSelectModule, [typeof MultiSelect], [typeof i1.CommonModule, typeof i2.SharedModule], [typeof MultiSelect, typeof i2.SharedModule]>;
    static ɵinj: i0.ɵɵInjectorDef<MultiSelectModule>;
}
