import { ElementRef, OnInit, AfterContentInit, OnDestroy, EventEmitter, TemplateRef, EmbeddedViewRef, ViewContainerRef, QueryList } from '@angular/core';
import { DomHandler } from '../dom/domhandler';
import { TreeNode } from '../common/treenode';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
import * as i2 from "../common/shared";
export declare class OrganizationChart implements AfterContentInit {
    el: ElementRef;
    domHandler: DomHandler;
    value: TreeNode[];
    style: any;
    styleClass: string;
    selectionMode: string;
    selection: any;
    selectionChange: EventEmitter<any>;
    onNodeSelect: EventEmitter<any>;
    onNodeUnselect: EventEmitter<any>;
    templates: QueryList<any>;
    templateMap: any;
    constructor(el: ElementRef, domHandler: DomHandler);
    get root(): TreeNode;
    ngAfterContentInit(): void;
    getTemplateForNode(node: TreeNode): TemplateRef<any>;
    onNodeClick(event: Event, node: TreeNode): void;
    findIndexInSelection(node: TreeNode): number;
    isSelected(node: TreeNode): boolean;
    static ɵfac: i0.ɵɵFactoryDef<OrganizationChart, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<OrganizationChart, "p-organizationChart", never, { "value": "value"; "style": "style"; "styleClass": "styleClass"; "selectionMode": "selectionMode"; "selection": "selection"; }, { "selectionChange": "selectionChange"; "onNodeSelect": "onNodeSelect"; "onNodeUnselect": "onNodeUnselect"; }, ["templates"], never>;
}
export declare class OrganizationChartNodeTemplateLoader implements OnInit, OnDestroy {
    viewContainer: ViewContainerRef;
    node: any;
    template: TemplateRef<any>;
    view: EmbeddedViewRef<any>;
    constructor(viewContainer: ViewContainerRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDef<OrganizationChartNodeTemplateLoader, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<OrganizationChartNodeTemplateLoader, "p-organizationChartNodeTemplateLoader", never, { "node": "node"; "template": "template"; }, {}, never, never>;
}
export declare class OrganizationChartNode {
    chart: OrganizationChart;
    node: TreeNode;
    root: boolean;
    first: boolean;
    last: boolean;
    constructor(chart: OrganizationChart);
    get leaf(): boolean;
    get colspan(): number;
    onNodeClick(event: Event, node: TreeNode): void;
    toggleNode(event: Event, node: TreeNode): void;
    isSelected(): boolean;
    static ɵfac: i0.ɵɵFactoryDef<OrganizationChartNode, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<OrganizationChartNode, "[pOrganizationChartNode]", never, { "node": "node"; "root": "root"; "first": "first"; "last": "last"; }, {}, never, never>;
}
export declare class OrganizationChartModule {
    static ɵmod: i0.ɵɵNgModuleDefWithMeta<OrganizationChartModule, [typeof OrganizationChart, typeof OrganizationChartNode, typeof OrganizationChartNodeTemplateLoader], [typeof i1.CommonModule], [typeof OrganizationChart, typeof i2.SharedModule]>;
    static ɵinj: i0.ɵɵInjectorDef<OrganizationChartModule>;
}
