import { ElementRef, OnDestroy, DoCheck, OnChanges, EventEmitter, IterableDiffers, OnInit, AfterViewChecked, SimpleChanges } from '@angular/core';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
export declare class Schedule implements DoCheck, OnDestroy, OnInit, OnChanges, AfterViewChecked {
    el: ElementRef;
    events: any[];
    header: any;
    style: any;
    styleClass: string;
    rtl: boolean;
    weekends: boolean;
    hiddenDays: number[];
    fixedWeekCount: boolean;
    weekNumbers: boolean;
    businessHours: any;
    height: any;
    contentHeight: any;
    aspectRatio: number;
    eventLimit: any;
    defaultDate: any;
    editable: boolean;
    droppable: boolean;
    eventStartEditable: boolean;
    eventDurationEditable: boolean;
    defaultView: string;
    allDaySlot: boolean;
    allDayText: string;
    slotDuration: any;
    slotLabelInterval: any;
    snapDuration: any;
    scrollTime: any;
    minTime: any;
    maxTime: any;
    slotEventOverlap: boolean;
    nowIndicator: boolean;
    dragRevertDuration: number;
    dragOpacity: number;
    dragScroll: boolean;
    eventOverlap: any;
    eventConstraint: any;
    locale: string;
    timezone: boolean | string;
    timeFormat: string | null;
    eventRender: Function;
    dayRender: Function;
    navLinks: boolean;
    options: any;
    onDayClick: EventEmitter<any>;
    onDrop: EventEmitter<any>;
    onEventClick: EventEmitter<any>;
    onEventMouseover: EventEmitter<any>;
    onEventMouseout: EventEmitter<any>;
    onEventDragStart: EventEmitter<any>;
    onEventDragStop: EventEmitter<any>;
    onEventDrop: EventEmitter<any>;
    onEventResizeStart: EventEmitter<any>;
    onEventResizeStop: EventEmitter<any>;
    onEventResize: EventEmitter<any>;
    onViewRender: EventEmitter<any>;
    onViewDestroy: EventEmitter<any>;
    initialized: boolean;
    stopNgOnChangesPropagation: boolean;
    differ: any;
    schedule: any;
    config: any;
    constructor(el: ElementRef, differs: IterableDiffers);
    ngOnInit(): void;
    ngAfterViewChecked(): void;
    ngOnChanges(changes: SimpleChanges): void;
    initialize(): void;
    ngDoCheck(): void;
    ngOnDestroy(): void;
    gotoDate(date: any): void;
    prev(): void;
    next(): void;
    prevYear(): void;
    nextYear(): void;
    today(): void;
    incrementDate(duration: any): void;
    changeView(viewName: string): void;
    getDate(): any;
    updateEvent(event: any): void;
    _findEvent(id: string): any;
    _updateEvent(event: any): void;
    static ɵfac: i0.ɵɵFactoryDef<Schedule, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<Schedule, "p-schedule", never, { "events": "events"; "header": "header"; "style": "style"; "styleClass": "styleClass"; "rtl": "rtl"; "weekends": "weekends"; "hiddenDays": "hiddenDays"; "fixedWeekCount": "fixedWeekCount"; "weekNumbers": "weekNumbers"; "businessHours": "businessHours"; "height": "height"; "contentHeight": "contentHeight"; "aspectRatio": "aspectRatio"; "eventLimit": "eventLimit"; "defaultDate": "defaultDate"; "editable": "editable"; "droppable": "droppable"; "eventStartEditable": "eventStartEditable"; "eventDurationEditable": "eventDurationEditable"; "defaultView": "defaultView"; "allDaySlot": "allDaySlot"; "allDayText": "allDayText"; "slotDuration": "slotDuration"; "slotLabelInterval": "slotLabelInterval"; "snapDuration": "snapDuration"; "scrollTime": "scrollTime"; "minTime": "minTime"; "maxTime": "maxTime"; "slotEventOverlap": "slotEventOverlap"; "nowIndicator": "nowIndicator"; "dragRevertDuration": "dragRevertDuration"; "dragOpacity": "dragOpacity"; "dragScroll": "dragScroll"; "eventOverlap": "eventOverlap"; "eventConstraint": "eventConstraint"; "locale": "locale"; "timezone": "timezone"; "timeFormat": "timeFormat"; "eventRender": "eventRender"; "dayRender": "dayRender"; "navLinks": "navLinks"; "options": "options"; }, { "onDayClick": "onDayClick"; "onDrop": "onDrop"; "onEventClick": "onEventClick"; "onEventMouseover": "onEventMouseover"; "onEventMouseout": "onEventMouseout"; "onEventDragStart": "onEventDragStart"; "onEventDragStop": "onEventDragStop"; "onEventDrop": "onEventDrop"; "onEventResizeStart": "onEventResizeStart"; "onEventResizeStop": "onEventResizeStop"; "onEventResize": "onEventResize"; "onViewRender": "onViewRender"; "onViewDestroy": "onViewDestroy"; }, never, never>;
}
export declare class ScheduleModule {
    static ɵmod: i0.ɵɵNgModuleDefWithMeta<ScheduleModule, [typeof Schedule], [typeof i1.CommonModule], [typeof Schedule]>;
    static ɵinj: i0.ɵɵInjectorDef<ScheduleModule>;
}
