import { EventEmitter } from '@angular/core';
import { SelectItem } from '../common/selectitem';
import { ObjectUtils } from '../utils/objectutils';
import { ControlValueAccessor } from '@angular/forms';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
export declare const SELECTBUTTON_VALUE_ACCESSOR: any;
export declare class SelectButton implements ControlValueAccessor {
    objectUtils: ObjectUtils;
    tabindex: number;
    multiple: boolean;
    style: any;
    styleClass: string;
    disabled: boolean;
    optionLabel: string;
    onOptionClick: EventEmitter<any>;
    onChange: EventEmitter<any>;
    value: any;
    focusedItem: HTMLInputElement;
    _options: any[];
    onModelChange: Function;
    onModelTouched: Function;
    constructor(objectUtils: ObjectUtils);
    get options(): any[];
    set options(val: any[]);
    writeValue(value: any): void;
    registerOnChange(fn: Function): void;
    registerOnTouched(fn: Function): void;
    setDisabledState(val: boolean): void;
    onItemClick(event: any, option: SelectItem, checkbox: HTMLInputElement, index: number): void;
    onFocus(event: Event): void;
    onBlur(event: any): void;
    isSelected(option: SelectItem): boolean;
    findItemIndex(option: SelectItem): number;
    static ɵfac: i0.ɵɵFactoryDef<SelectButton, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<SelectButton, "p-selectButton", never, { "tabindex": "tabindex"; "multiple": "multiple"; "style": "style"; "styleClass": "styleClass"; "disabled": "disabled"; "optionLabel": "optionLabel"; "options": "options"; }, { "onOptionClick": "onOptionClick"; "onChange": "onChange"; }, never, never>;
}
export declare class SelectButtonModule {
    static ɵmod: i0.ɵɵNgModuleDefWithMeta<SelectButtonModule, [typeof SelectButton], [typeof i1.CommonModule], [typeof SelectButton]>;
    static ɵinj: i0.ɵɵInjectorDef<SelectButtonModule>;
}
