import { ElementRef, AfterViewInit, AfterViewChecked, OnDestroy, EventEmitter, Renderer2, ChangeDetectorRef } from '@angular/core';
import { DomHandler } from '../dom/domhandler';
import { MenuItem } from '../common/menuitem';
import { Router } from '@angular/router';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
import * as i2 from "../button/button";
import * as i3 from "@angular/router";
export declare class SplitButton implements AfterViewInit, AfterViewChecked, OnDestroy {
    el: ElementRef;
    domHandler: DomHandler;
    renderer: Renderer2;
    router: Router;
    cd: ChangeDetectorRef;
    model: MenuItem[];
    icon: string;
    iconPos: string;
    label: string;
    onClick: EventEmitter<any>;
    onDropdownClick: EventEmitter<any>;
    style: any;
    styleClass: string;
    menuStyle: any;
    menuStyleClass: string;
    disabled: boolean;
    tabindex: number;
    appendTo: any;
    buttonViewChild: ElementRef;
    overlayViewChild: ElementRef;
    menuVisible: boolean;
    documentClickListener: any;
    dropdownClick: boolean;
    shown: boolean;
    constructor(el: ElementRef, domHandler: DomHandler, renderer: Renderer2, router: Router, cd: ChangeDetectorRef);
    ngAfterViewInit(): void;
    ngAfterViewChecked(): void;
    onDefaultButtonClick(event: Event): void;
    itemClick(event: Event, item: MenuItem): void;
    show(): void;
    onShow(): void;
    onDropdownButtonClick(event: Event): void;
    alignPanel(): void;
    bindDocumentClickListener(): void;
    unbindDocumentClickListener(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDef<SplitButton, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<SplitButton, "p-splitButton", never, { "model": "model"; "icon": "icon"; "iconPos": "iconPos"; "label": "label"; "style": "style"; "styleClass": "styleClass"; "menuStyle": "menuStyle"; "menuStyleClass": "menuStyleClass"; "disabled": "disabled"; "tabindex": "tabindex"; "appendTo": "appendTo"; }, { "onClick": "onClick"; "onDropdownClick": "onDropdownClick"; }, never, never>;
}
export declare class SplitButtonModule {
    static ɵmod: i0.ɵɵNgModuleDefWithMeta<SplitButtonModule, [typeof SplitButton], [typeof i1.CommonModule, typeof i2.ButtonModule, typeof i3.RouterModule], [typeof SplitButton, typeof i2.ButtonModule, typeof i3.RouterModule]>;
    static ɵinj: i0.ɵɵInjectorDef<SplitButtonModule>;
}
