import { ElementRef, OnDestroy, EventEmitter, AfterContentInit, QueryList, TemplateRef, EmbeddedViewRef, ViewContainerRef } from '@angular/core';
import { BlockableUI } from '../common/blockableui';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
import * as i2 from "../common/shared";
export declare class TabViewNav {
    tabs: TabPanel[];
    orientation: string;
    onTabClick: EventEmitter<any>;
    onTabCloseClick: EventEmitter<any>;
    getDefaultHeaderClass(tab: TabPanel): string;
    clickTab(event: any, tab: TabPanel): void;
    clickClose(event: any, tab: TabPanel): void;
    static ɵfac: i0.ɵɵFactoryDef<TabViewNav, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<TabViewNav, "[p-tabViewNav]", never, { "tabs": "tabs"; "orientation": "orientation"; }, { "onTabClick": "onTabClick"; "onTabCloseClick": "onTabCloseClick"; }, never, never>;
}
export declare class TabPanel implements AfterContentInit, OnDestroy {
    viewContainer: ViewContainerRef;
    header: string;
    disabled: boolean;
    closable: boolean;
    headerStyle: any;
    headerStyleClass: string;
    leftIcon: string;
    rightIcon: string;
    cache: boolean;
    templates: QueryList<any>;
    contentTemplate: TemplateRef<any>;
    constructor(viewContainer: ViewContainerRef);
    closed: boolean;
    view: EmbeddedViewRef<any>;
    _selected: boolean;
    loaded: boolean;
    ngAfterContentInit(): void;
    get selected(): boolean;
    set selected(val: boolean);
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDef<TabPanel, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<TabPanel, "p-tabPanel", never, { "header": "header"; "disabled": "disabled"; "closable": "closable"; "headerStyle": "headerStyle"; "headerStyleClass": "headerStyleClass"; "leftIcon": "leftIcon"; "rightIcon": "rightIcon"; "cache": "cache"; "selected": "selected"; }, {}, ["templates"], ["*"]>;
}
export declare class TabView implements AfterContentInit, BlockableUI {
    el: ElementRef;
    orientation: string;
    style: any;
    styleClass: string;
    controlClose: boolean;
    tabPanels: QueryList<TabPanel>;
    onChange: EventEmitter<any>;
    onClose: EventEmitter<any>;
    initialized: boolean;
    tabs: TabPanel[];
    _activeIndex: number;
    _lazy: boolean;
    constructor(el: ElementRef);
    get lazy(): boolean;
    set lazy(val: boolean);
    ngAfterContentInit(): void;
    initTabs(): void;
    open(event: Event, tab: TabPanel): void;
    close(event: Event, tab: TabPanel): void;
    closeTab(tab: TabPanel): void;
    findSelectedTab(): TabPanel;
    findTabIndex(tab: TabPanel): number;
    getBlockableElement(): HTMLElement;
    get activeIndex(): number;
    set activeIndex(val: number);
    static ɵfac: i0.ɵɵFactoryDef<TabView, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<TabView, "p-tabView", never, { "orientation": "orientation"; "style": "style"; "styleClass": "styleClass"; "controlClose": "controlClose"; "lazy": "lazy"; "activeIndex": "activeIndex"; }, { "onChange": "onChange"; "onClose": "onClose"; }, ["tabPanels"], ["*"]>;
}
export declare class TabViewModule {
    static ɵmod: i0.ɵɵNgModuleDefWithMeta<TabViewModule, [typeof TabView, typeof TabPanel, typeof TabViewNav], [typeof i1.CommonModule, typeof i2.SharedModule], [typeof TabView, typeof TabPanel, typeof TabViewNav, typeof i2.SharedModule]>;
    static ɵinj: i0.ɵɵInjectorDef<TabViewModule>;
}
