import { AfterViewInit, AfterViewChecked, OnDestroy, ElementRef } from '@angular/core';
import { DomHandler } from '../dom/domhandler';
import { TerminalService } from './terminalservice';
import { Subscription } from 'rxjs';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
import * as i2 from "@angular/forms";
export declare class Terminal implements AfterViewInit, AfterViewChecked, OnDestroy {
    el: ElementRef;
    domHandler: DomHandler;
    terminalService: TerminalService;
    welcomeMessage: string;
    prompt: string;
    style: any;
    styleClass: string;
    commands: any[];
    command: string;
    container: Element;
    commandProcessed: boolean;
    subscription: Subscription;
    constructor(el: ElementRef, domHandler: DomHandler, terminalService: TerminalService);
    ngAfterViewInit(): void;
    ngAfterViewChecked(): void;
    set response(value: string);
    handleCommand(event: KeyboardEvent): void;
    focus(element: HTMLElement): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDef<Terminal, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<Terminal, "p-terminal", never, { "welcomeMessage": "welcomeMessage"; "prompt": "prompt"; "style": "style"; "styleClass": "styleClass"; "response": "response"; }, {}, never, never>;
}
export declare class TerminalModule {
    static ɵmod: i0.ɵɵNgModuleDefWithMeta<TerminalModule, [typeof Terminal], [typeof i1.CommonModule, typeof i2.FormsModule], [typeof Terminal]>;
    static ɵinj: i0.ɵɵInjectorDef<TerminalModule>;
}
