"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var i0 = require("@angular/core");
var i1 = require("@angular/common");
var _c0 = ["checkbox"];
function ToggleButton_span_4_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "span");
} if (rf & 2) {
    var ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵclassMap(ctx_r1.getIconClass());
} }
var _c1 = function (a1, a2, a3, a4, a5, a6) { return { "ui-button ui-togglebutton ui-widget ui-state-default ui-corner-all": true, "ui-button-text-only": a1, "ui-button-text-icon-left": a2, "ui-button-icon-only": a3, "ui-state-active": a4, "ui-state-focus": a5, "ui-state-disabled": a6 }; };
exports.TOGGLEBUTTON_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return ToggleButton; }),
    multi: true
};
var ToggleButton = /** @class */ (function () {
    function ToggleButton() {
        this.onLabel = 'Yes';
        this.offLabel = 'No';
        this.onChange = new core_1.EventEmitter();
        this.checked = false;
        this.focus = false;
        this.onModelChange = function () { };
        this.onModelTouched = function () { };
    }
    ToggleButton.prototype.ngAfterViewInit = function () {
        this.checkbox = this.checkboxViewChild.nativeElement;
    };
    ToggleButton.prototype.getIconClass = function () {
        var baseClass = 'ui-button-icon-left fa fa-fw';
        return baseClass + ' ' + (this.checked ? this.onIcon : this.offIcon);
    };
    ToggleButton.prototype.toggle = function (event) {
        if (!this.disabled) {
            this.checked = !this.checked;
            this.onModelChange(this.checked);
            this.onModelTouched();
            this.onChange.emit({
                originalEvent: event,
                checked: this.checked
            });
            this.checkbox.focus();
        }
    };
    ToggleButton.prototype.onFocus = function () {
        this.focus = true;
    };
    ToggleButton.prototype.onBlur = function () {
        this.focus = false;
        this.onModelTouched();
    };
    ToggleButton.prototype.writeValue = function (value) {
        this.checked = value;
    };
    ToggleButton.prototype.registerOnChange = function (fn) {
        this.onModelChange = fn;
    };
    ToggleButton.prototype.registerOnTouched = function (fn) {
        this.onModelTouched = fn;
    };
    ToggleButton.prototype.setDisabledState = function (val) {
        this.disabled = val;
    };
    Object.defineProperty(ToggleButton.prototype, "hasOnLabel", {
        get: function () {
            return this.onLabel && this.onLabel.length > 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ToggleButton.prototype, "hasOffLabel", {
        get: function () {
            return this.onLabel && this.onLabel.length > 0;
        },
        enumerable: true,
        configurable: true
    });
    ToggleButton.ɵfac = function ToggleButton_Factory(t) { return new (t || ToggleButton)(); };
    ToggleButton.ɵcmp = i0.ɵɵdefineComponent({ type: ToggleButton, selectors: [["p-toggleButton"]], viewQuery: function ToggleButton_Query(rf, ctx) { if (rf & 1) {
            i0.ɵɵviewQuery(_c0, true);
        } if (rf & 2) {
            var _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.checkboxViewChild = _t.first);
        } }, inputs: { onLabel: "onLabel", offLabel: "offLabel", onIcon: "onIcon", offIcon: "offIcon", disabled: "disabled", style: "style", styleClass: "styleClass", inputId: "inputId", tabindex: "tabindex" }, outputs: { onChange: "onChange" }, features: [i0.ɵɵProvidersFeature([exports.TOGGLEBUTTON_VALUE_ACCESSOR])], decls: 7, vars: 16, consts: [[3, "ngClass", "ngStyle", "click"], [1, "ui-helper-hidden-accessible"], ["type", "checkbox", 3, "checked", "focus", "blur"], ["checkbox", ""], [3, "class", 4, "ngIf"], [1, "ui-button-text", "ui-unselectable-text"]], template: function ToggleButton_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "div", 0);
            i0.ɵɵlistener("click", function ToggleButton_Template_div_click_0_listener($event) { return ctx.toggle($event); });
            i0.ɵɵelementStart(1, "div", 1);
            i0.ɵɵelementStart(2, "input", 2, 3);
            i0.ɵɵlistener("focus", function ToggleButton_Template_input_focus_2_listener() { return ctx.onFocus(); })("blur", function ToggleButton_Template_input_blur_2_listener() { return ctx.onBlur(); });
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵtemplate(4, ToggleButton_span_4_Template, 1, 2, "span", 4);
            i0.ɵɵelementStart(5, "span", 5);
            i0.ɵɵtext(6);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵclassMap(ctx.styleClass);
            i0.ɵɵproperty("ngClass", i0.ɵɵpureFunction6(9, _c1, !ctx.onIcon && !ctx.offIcon, ctx.onIcon && ctx.offIcon && ctx.hasOnLabel && ctx.hasOffLabel, ctx.onIcon && ctx.offIcon && !ctx.hasOnLabel && !ctx.hasOffLabel, ctx.checked, ctx.focus, ctx.disabled))("ngStyle", ctx.style);
            i0.ɵɵadvance(2);
            i0.ɵɵproperty("checked", ctx.checked);
            i0.ɵɵattribute("id", ctx.inputId)("tabindex", ctx.tabindex);
            i0.ɵɵadvance(2);
            i0.ɵɵproperty("ngIf", ctx.onIcon || ctx.offIcon);
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate(ctx.checked ? ctx.hasOnLabel ? ctx.onLabel : "ui-btn" : ctx.hasOffLabel ? ctx.offLabel : "ui-btn");
        } }, directives: [i1.NgClass, i1.NgStyle, i1.NgIf], encapsulation: 2 });
    return ToggleButton;
}());
exports.ToggleButton = ToggleButton;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(ToggleButton, [{
        type: core_1.Component,
        args: [{
                selector: 'p-toggleButton',
                template: "\n        <div [ngClass]=\"{'ui-button ui-togglebutton ui-widget ui-state-default ui-corner-all': true, 'ui-button-text-only': (!onIcon&&!offIcon), \n                'ui-button-text-icon-left': (onIcon&&offIcon&&hasOnLabel&&hasOffLabel), 'ui-button-icon-only': (onIcon&&offIcon&&!hasOnLabel&&!hasOffLabel),\n                'ui-state-active': checked,'ui-state-focus':focus,'ui-state-disabled':disabled}\" [ngStyle]=\"style\" [class]=\"styleClass\" \n                (click)=\"toggle($event)\">\n            <div class=\"ui-helper-hidden-accessible\">\n                <input #checkbox type=\"checkbox\" [attr.id]=\"inputId\" [checked]=\"checked\" (focus)=\"onFocus()\" (blur)=\"onBlur()\" [attr.tabindex]=\"tabindex\">\n            </div>\n            <span *ngIf=\"onIcon||offIcon\" [class]=\"getIconClass()\"></span>\n            <span class=\"ui-button-text ui-unselectable-text\">{{checked ? hasOnLabel ? onLabel : 'ui-btn' : hasOffLabel ? offLabel : 'ui-btn'}}</span>\n        </div>\n    ",
                providers: [exports.TOGGLEBUTTON_VALUE_ACCESSOR]
            }]
    }], null, { onLabel: [{
            type: core_1.Input
        }], offLabel: [{
            type: core_1.Input
        }], onIcon: [{
            type: core_1.Input
        }], offIcon: [{
            type: core_1.Input
        }], disabled: [{
            type: core_1.Input
        }], style: [{
            type: core_1.Input
        }], styleClass: [{
            type: core_1.Input
        }], inputId: [{
            type: core_1.Input
        }], tabindex: [{
            type: core_1.Input
        }], onChange: [{
            type: core_1.Output
        }], checkboxViewChild: [{
            type: core_1.ViewChild,
            args: ['checkbox']
        }] }); })();
var ToggleButtonModule = /** @class */ (function () {
    function ToggleButtonModule() {
    }
    ToggleButtonModule.ɵmod = i0.ɵɵdefineNgModule({ type: ToggleButtonModule });
    ToggleButtonModule.ɵinj = i0.ɵɵdefineInjector({ factory: function ToggleButtonModule_Factory(t) { return new (t || ToggleButtonModule)(); }, imports: [[common_1.CommonModule]] });
    return ToggleButtonModule;
}());
exports.ToggleButtonModule = ToggleButtonModule;
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(ToggleButtonModule, { declarations: [ToggleButton], imports: [common_1.CommonModule], exports: [ToggleButton] }); })();
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(ToggleButtonModule, [{
        type: core_1.NgModule,
        args: [{
                imports: [common_1.CommonModule],
                exports: [ToggleButton],
                declarations: [ToggleButton]
            }]
    }], null, null); })();
//# sourceMappingURL=togglebutton.js.map