import { ElementRef, OnDestroy, Renderer2 } from '@angular/core';
import { DomHandler } from '../dom/domhandler';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
export declare class Tooltip implements OnDestroy {
    el: ElementRef;
    domHandler: DomHandler;
    renderer: Renderer2;
    tooltipPosition: string;
    tooltipEvent: string;
    appendTo: any;
    positionStyle: string;
    tooltipStyleClass: string;
    tooltipZIndex: string;
    disabled: boolean;
    escape: boolean;
    showDelay: number;
    hideDelay: number;
    life: number;
    container: any;
    styleClass: string;
    tooltipText: any;
    showTimeout: any;
    hideTimeout: any;
    lifeTimeout: any;
    documentResizeListener: Function;
    active: boolean;
    _text: string;
    constructor(el: ElementRef, domHandler: DomHandler, renderer: Renderer2);
    onMouseEnter(e: Event): void;
    onMouseLeave(e: Event): void;
    onFocus(e: Event): void;
    onBlur(e: Event): void;
    onClick(e: Event): void;
    activate(): void;
    deactivate(useDelay: any): void;
    get text(): string;
    set text(text: string);
    create(): void;
    show(): void;
    hide(): void;
    updateText(): void;
    align(): void;
    getHostOffset(): {
        left: any;
        top: any;
    };
    alignRight(): void;
    alignLeft(): void;
    alignTop(): void;
    alignBottom(): void;
    preAlign(): void;
    isOutOfBounds(): boolean;
    bindDocumentResizeListener(): void;
    unbindDocumentResizeListener(): void;
    destroy(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDef<Tooltip, never>;
    static ɵdir: i0.ɵɵDirectiveDefWithMeta<Tooltip, "[pTooltip]", never, { "tooltipPosition": "tooltipPosition"; "tooltipEvent": "tooltipEvent"; "appendTo": "appendTo"; "positionStyle": "positionStyle"; "tooltipStyleClass": "tooltipStyleClass"; "tooltipZIndex": "tooltipZIndex"; "disabled": "tooltipDisabled"; "escape": "escape"; "showDelay": "showDelay"; "hideDelay": "hideDelay"; "life": "life"; "text": "pTooltip"; }, {}, never>;
}
export declare class TooltipModule {
    static ɵmod: i0.ɵɵNgModuleDefWithMeta<TooltipModule, [typeof Tooltip], [typeof i1.CommonModule], [typeof Tooltip]>;
    static ɵinj: i0.ɵɵInjectorDef<TooltipModule>;
}
