import { EventEmitter, AfterContentInit, ElementRef, ChangeDetectorRef, QueryList, OnInit, Renderer2 } from '@angular/core';
import { TreeNode } from '../common/treenode';
import { Header, Footer, Column } from '../common/shared';
import { Subscription } from 'rxjs';
import { DomHandler } from '../dom/domhandler';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
import * as i2 from "../common/shared";
export declare class TreeTable implements AfterContentInit {
    el: ElementRef;
    domHandler: DomHandler;
    changeDetector: ChangeDetectorRef;
    renderer: Renderer2;
    value: TreeNode[];
    selectionMode: string;
    selection: any;
    style: any;
    styleClass: string;
    labelExpand: string;
    labelCollapse: string;
    metaKeySelection: boolean;
    contextMenu: any;
    toggleColumnIndex: number;
    tableStyle: any;
    tableStyleClass: string;
    collapsedIcon: string;
    expandedIcon: string;
    onRowDblclick: EventEmitter<any>;
    selectionChange: EventEmitter<any>;
    onNodeSelect: EventEmitter<any>;
    onNodeUnselect: EventEmitter<any>;
    onNodeExpand: EventEmitter<any>;
    onNodeCollapse: EventEmitter<any>;
    onContextMenuSelect: EventEmitter<any>;
    header: Header;
    footer: Footer;
    cols: QueryList<Column>;
    tableViewChild: ElementRef;
    rowTouched: boolean;
    columns: Column[];
    columnsSubscription: Subscription;
    constructor(el: ElementRef, domHandler: DomHandler, changeDetector: ChangeDetectorRef, renderer: Renderer2);
    ngAfterContentInit(): void;
    initColumns(): void;
    onRowClick(event: MouseEvent, node: TreeNode): void;
    onRowTouchEnd(): void;
    onRowRightClick(event: MouseEvent, node: TreeNode): void;
    findIndexInSelection(node: TreeNode): number;
    propagateSelectionUp(node: TreeNode, select: boolean): void;
    propagateSelectionDown(node: TreeNode, select: boolean): void;
    isSelected(node: TreeNode): boolean;
    isSingleSelectionMode(): boolean;
    isMultipleSelectionMode(): boolean;
    isCheckboxSelectionMode(): boolean;
    hasFooter(): boolean;
    static ɵfac: i0.ɵɵFactoryDef<TreeTable, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<TreeTable, "p-treeTable", never, { "value": "value"; "selectionMode": "selectionMode"; "selection": "selection"; "style": "style"; "styleClass": "styleClass"; "labelExpand": "labelExpand"; "labelCollapse": "labelCollapse"; "metaKeySelection": "metaKeySelection"; "contextMenu": "contextMenu"; "toggleColumnIndex": "toggleColumnIndex"; "tableStyle": "tableStyle"; "tableStyleClass": "tableStyleClass"; "collapsedIcon": "collapsedIcon"; "expandedIcon": "expandedIcon"; }, { "onRowDblclick": "onRowDblclick"; "selectionChange": "selectionChange"; "onNodeSelect": "onNodeSelect"; "onNodeUnselect": "onNodeUnselect"; "onNodeExpand": "onNodeExpand"; "onNodeCollapse": "onNodeCollapse"; "onContextMenuSelect": "onContextMenuSelect"; }, ["header", "footer", "cols"], ["p-header", "p-footer"]>;
}
export declare class UITreeRow implements OnInit {
    treeTable: TreeTable;
    node: TreeNode;
    parentNode: TreeNode;
    level: number;
    labelExpand: string;
    labelCollapse: string;
    constructor(treeTable: TreeTable);
    ngOnInit(): void;
    toggle(event: Event): void;
    isLeaf(): boolean;
    isSelected(): boolean;
    onRowClick(event: MouseEvent): void;
    onRowRightClick(event: MouseEvent): void;
    rowDblClick(event: MouseEvent): void;
    onRowTouchEnd(): void;
    resolveFieldData(data: any, field: string): any;
    static ɵfac: i0.ɵɵFactoryDef<UITreeRow, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<UITreeRow, "[pTreeRow]", never, { "node": "node"; "parentNode": "parentNode"; "level": "level"; "labelExpand": "labelExpand"; "labelCollapse": "labelCollapse"; }, {}, never, never>;
}
export declare class TreeTableModule {
    static ɵmod: i0.ɵɵNgModuleDefWithMeta<TreeTableModule, [typeof TreeTable, typeof UITreeRow], [typeof i1.CommonModule, typeof i2.SharedModule], [typeof TreeTable, typeof i2.SharedModule]>;
    static ɵinj: i0.ɵɵInjectorDef<TreeTableModule>;
}
